define(["@grafana/data","react","@emotion/css","@grafana/ui","d3","@grafana/runtime","lodash"],((n,t,e,r,o,i,a)=>(()=>{"use strict";var u={248:(n,t,e)=>{e.d(t,{A:()=>u});var r=e(942),o=e.n(r),i=e(278),a=e.n(i)()(o());a.push([n.id,".axis path,.axis line{fill:none;stroke:#d8d9da;shape-rendering:crispEdges}.axis{font:10px sans-serif}.axis text{-webkit-transition:fill-opacity 250ms linear;color:#7b7b7b;fill:currentColor}.axis path{display:none}.axis line{stroke:#7b7b7b;shape-rendering:crispEdges}.horizon{border-bottom:solid 1px #7b7b7b;overflow:hidden;position:relative}.horizon{border-top:solid 1px #7b7b7b;border-bottom:solid 1px #7b7b7b}.horizon+.horizon{border-top:none}.horizon canvas{display:block}.horizon .title,.horizon .value{bottom:0;color:#d8d9da;line-height:30px;margin:0 6px;position:absolute;text-shadow:-1px -1px 0 #1f1d1d,1px -1px 0 #1f1d1d,-1px 1px 0 #1f1d1d,1px 1px 0 #1f1d1d;white-space:nowrap}.horizon .title{left:0}.horizon .value{right:0}.line{background:#d8d9da;z-index:2}.cubism-wrapper{width:100%}.cubism-canvas-wrapper{width:100%}.cubism-panel{position:relative;padding:0;width:100%}","",{version:3,sources:["webpack://./sass/cubism.scss","webpack://./sass/_variables.dark.scss"],names:[],mappings:"AAGA,sBACC,SAAA,CACA,cCakB,CDZlB,0BAAA,CAGD,MACC,oBAAA,CAGD,WACC,4CAAA,CACA,aCCkB,CAAA,iBAAA,CDInB,WACC,YAAA,CAGD,WACC,cCTkB,CDUlB,0BAAA,CAMD,SACC,+BAAA,CACA,eAAA,CACA,iBAAA,CAGD,SACC,4BAAA,CACA,+BAAA,CAGD,kBACC,eAAA,CAGD,gBACC,aAAA,CAGD,gCAEC,QAAA,CACA,aCpCkB,CDqClB,gBAAA,CACA,YAAA,CACA,iBAAA,CACA,uFAAA,CACA,kBAAA,CAGD,gBACC,MAAA,CAGD,gBACC,OAAA,CAMD,MACC,kBCxDkB,CD0DlB,SAAA,CAMD,gBACE,UAAA,CAGF,uBACE,UAAA,CAGF,cACE,iBAAA,CACA,SAAA,CACA,UAAA",sourcesContent:["/*-----------------------------------------------------------------------------\nAXIS\n-----------------------------------------------------------------------------*/\n.axis path, .axis line {\n\tfill: none;\n\tstroke: $body-color;\n\tshape-rendering: crispEdges;\n}\n\n.axis {\n\tfont: 10px sans-serif\n}\n\n.axis text {\n\t-webkit-transition: fill-opacity 250ms linear;\n\tcolor: $text-color-weak;\n\tfill: currentColor;\n\n}\n\n.axis path {\n\tdisplay: none\n}\n\n.axis line {\n\tstroke: $text-color-weak;\n\tshape-rendering: crispEdges\n}\n\n/*-----------------------------------------------------------------------------\nHORIZON\n-----------------------------------------------------------------------------*/\n.horizon {\n\tborder-bottom: solid 1px $text-color-weak;\n\toverflow: hidden;\n\tposition: relative\n}\n\n.horizon {\n\tborder-top: solid 1px $text-color-weak;\n\tborder-bottom: solid 1px $text-color-weak\n}\n\n.horizon + .horizon {\n\tborder-top: none\n}\n\n.horizon canvas {\n\tdisplay: block\n}\n\n.horizon .title,\n.horizon .value {\n\tbottom: 0;\n\tcolor: $text-color;\n\tline-height: 30px;\n\tmargin: 0 6px;\n\tposition: absolute;\n\ttext-shadow: -1px -1px 0 $page-bg, 1px -1px 0 $page-bg, -1px 1px 0 $page-bg, 1px 1px 0 $page-bg;\n\twhite-space: nowrap\n}\n\n.horizon .title {\n\tleft: 0\n}\n\n.horizon .value {\n\tright: 0\n}\n\n/*-----------------------------------------------------------------------------\nMarker\n-----------------------------------------------------------------------------*/\n.line {\n\tbackground: $body-color;\n\t//opacity: .2;\n\tz-index: 2;\n}\n\n/*-----------------------------------------------------------------------------\nDIVS\n-----------------------------------------------------------------------------*/\n.cubism-wrapper {\n  width: 100%;\n}\n\n.cubism-canvas-wrapper {\n  width: 100%;\n}\n\n.cubism-panel {\n  position: relative;\n  padding: 0;\n  width: 100%;\n}\n","// Global values\n// --------------------------------------------------\n\n\n// Grays\n// -------------------------\n$black:                 #000;\n\n// -------------------------\n$black:            #000;\n$dark-1:           #141414;\n$dark-2:           #1f1d1d;\n$dark-3:           #292929;\n$dark-4:           #333333;\n$dark-5:           #444444;\n$gray-1:           #555555;\n$gray-2:           #7B7B7B;\n$gray-3:           #b3b3b3;\n$gray-4:           #D8D9DA;\n$gray-5:           #ECECEC;\n$gray-6:           #f4f5f8;\n$gray-7:           #fbfbfb;\n\n$white:            #fff;\n\n// Accent colors\n// -------------------------\n$blue:                  #33B5E5;\n$blue-dark:             #005f81;\n$green:                 #609000;\n$red:                   #CC3900;\n$yellow:                #ECBB13;\n$pink:                  #FF4444;\n$purple:                #9933CC;\n$variable:              #32D1DF;\n$orange:                #dF7518;\n\n$brand-primary:         $orange;\n$brand-success:         $green;\n$brand-warning:         $brand-primary;\n$brand-danger:          $red;\n$brand-text-highlight:  #f7941d;\n\n// Status colors\n// -------------------------\n$online:                #10a345;\n$warn:                  #ffc03c;\n$critical:              #ed2e18;\n\n// Scaffolding\n// -------------------------\n$body-bg:  \t\t\t   \t    rgb(20,20,20);\n$page-bg:  \t\t\t   \t    $dark-2;\n$body-color:   \t\t \t    $gray-4;\n$text-color:   \t   \t\t  $gray-4;\n$text-color-strong: \t  $white;\n$text-color-weak: \t\t  $gray-2;\n$text-color-faint:      $gray-1;\n$text-color-emphasis: \t$gray-5;\n\n$text-shadow-strong: 1px 1px 4px $black;\n$text-shadow-faint: 1px 1px 4px rgb(45, 45, 45);\n\n// gradients\n$brand-gradient: linear-gradient(to right, rgba(255,213,0,0.7) 0%, rgba(255,68,0,0.7) 99%, rgba(255,68,0,0.7) 100%);\n$page-gradient: linear-gradient(60deg, transparent 70%, darken($page-bg, 4%) 98%);\n\n// Links\n// -------------------------\n$link-color:              darken($white, 11%);\n$link-color-disabled:     darken($link-color, 30%);\n$link-hover-color:        $white;\n$external-link-color:     $blue;\n\n// Typography\n// -------------------------\n$headings-color:       darken($white,11%);\n$abbr-border-color: \t $gray-3 !default;\n$text-muted: \t\t\t     $text-color-weak;\n\n$blockquote-small-color:  $gray-3 !default;\n$blockquote-border-color: $gray-4 !default;\n\n$hr-border-color: rgba(0,0,0,.1) !default;\n\n// Components\n$component-active-color: #fff !default;\n$component-active-bg:    $brand-primary !default;\n\n// Panel\n// -------------------------\n$panel-bg: \t\t\t\t $dark-2;\n$panel-border: \t\t\t solid 1px $dark-3;\n\n$divider-border-color:  #555;\n\n// Graphite Target Editor\n$tight-form-border:     #050505;\n$tight-form-bg:     \t$dark-3;\n\n$tight-form-func-bg: \t\t    #333;\n$tight-form-func-highlight-bg:  #444;\n\n$modal-background: $black;\n$code-tag-bg:      $dark-5;\n$code-tag-border:  lighten($code-tag-bg, 2%);\n\n\n// Lists\n$grafanaListBackground:  \t  $dark-3;\n$grafanaListAccent:      \t  lighten($dark-2, 2%);\n$grafanaListBorderTop:      $dark-3;\n$grafanaListBorderBottom:   $black;\n$grafanaListHighlight:      #333;\n$grafanaListMainLinkColor:  $text-color;\n\n// Scrollbars\n$scrollbarBackground: #3a3a3a;\n$scrollbarBackground2: #3a3a3a;\n$scrollbarBorder: black;\n\n// Tables\n// -------------------------\n$table-bg:                    transparent; // overall background-color\n$table-bg-accent:             $dark-3; // for striping\n$table-bg-hover:              $dark-4; // for hover\n$table-border:                $dark-3; // table and cell border\n\n// Buttons\n// -------------------------\n\n$btn-primary-bg:              $brand-primary;\n$btn-primary-bg-hl:           lighten($brand-primary, 8%);\n\n$btn-secondary-bg:            $blue-dark;\n$btn-secondary-bg-hl:     \t\tlighten($blue-dark, 5%);\n\n$btn-success-bg:              lighten($green, 3%);\n$btn-success-bg-hl:     \t    darken($green, 3%);\n\n$btn-warning-bg:              $brand-warning;\n$btn-warning-bg-hl:     \t    lighten($brand-warning, 8%);\n\n$btn-danger-bg:               $red;\n$btn-danger-bg-hl:            lighten($red, 5%);\n\n$btn-inverse-bg:              $dark-3;\n$btn-inverse-bg-hl:     \t    lighten($dark-3, 4%);\n$btn-inverse-text-color:      $link-color;\n\n$btn-link-color:              $gray-3;\n\n$iconContainerBackground:\t    $black;\n\n// Forms\n// -------------------------\n$input-bg:                       $dark-4;\n$input-bg-disabled:              $dark-3;\n\n$input-color:                    $gray-4;\n$input-border-color:             $dark-4;\n$input-box-shadow:               inset 1px 0px 0.3rem 0px rgba(150, 150, 150, 0.10);\n$input-border-focus:             $input-border-color !default;\n$input-box-shadow-focus:         rgba(102,175,233,.6) !default;\n$input-color-placeholder:        $gray-1 !default;\n$input-label-bg:\t\t\t\t         $dark-3;\n\n// Search\n$search-shadow: 0 0 35px 0 $body-bg;\n\n// Dropdowns\n// -------------------------\n$dropdownBackground:            $dark-3;\n$dropdownBorder:                rgba(0,0,0,.2);\n$dropdownDividerTop:            transparent;\n$dropdownDividerBottom:         #444;\n$dropdownDivider:               $dropdownDividerBottom;\n$dropdownTitle:                 $link-color-disabled;\n\n$dropdownLinkColor:             $text-color;\n$dropdownLinkColorHover:        $white;\n$dropdownLinkColorActive:       $white;\n\n$dropdownLinkBackgroundActive:  $dark-4;\n$dropdownLinkBackgroundHover:   $dark-4;\n\n\n// COMPONENT VARIABLES\n// --------------------------------------------------\n\n// -------------------------\n$placeholderText:         darken($text-color, 25%);\n\n\n// Horizontal forms & lists\n// -------------------------\n$horizontalComponentOffset:       180px;\n\n\n// Wells\n// -------------------------\n$wellBackground:                  #131517;\n\n$navbarHeight:                    52px;\n$navbarBackgroundHighlight:       $dark-3;\n$navbarBackground:                $dark-3;\n$navbarBorder:                    1px solid $body-bg;\n\n$navbarText:                      $gray-4;\n$navbarLinkColor:                 $gray-4;\n$navbarLinkColorHover:            $white;\n$navbarLinkColorActive:           $navbarLinkColorHover;\n$navbarLinkBackgroundHover:       transparent;\n$navbarLinkBackgroundActive:      $navbarBackground;\n$navbarBrandColor:                $link-color;\n$navbarDropdownShadow:            inset 0px 4px 10px -4px $body-bg;\n\n$navbarButtonBackground:          lighten($navbarBackground, 3%);\n$navbarButtonBackgroundHighlight: lighten($navbarBackground, 5%);\n\n// Sidemenu\n// -------------------------\n$side-menu-bg:            $body-bg;\n$side-menu-item-hover-bg: $dark-3;\n$side-menu-opacity:\t\t  0.97;\n\n// Pagination\n// -------------------------\n$paginationBackground:                $body-bg;\n$paginationBorder:                    transparent;\n$paginationActiveBackground:          $blue;\n\n// Form states and alerts\n// -------------------------\n$state-warning-text:      $warn;\n$state-warning-bg:        $brand-warning;\n\n$errorText:               #E84D4D;\n$errorBackground:         $btn-danger-bg;\n\n$successText:             #12D95A;\n$successBackground:       $btn-success-bg;\n\n$infoText:                $blue-dark;\n$infoBackground:          $blue-dark;\n\n// popover\n$popover-bg:         $dark-4;\n$popover-color:      $text-color;\n\n$popover-help-bg:         $btn-secondary-bg;\n$popover-help-color:      $text-color;\n\n\n// Tooltips and popovers\n// -------------------------\n$tooltipColor:            $popover-help-color;\n$tooltipBackground:       $popover-help-bg;\n$tooltipArrowWidth:       5px;\n$tooltipArrowColor:       $tooltipBackground;\n$tooltipLinkColor:        $link-color;\n$graph-tooltip-bg:        $dark-4;\n\n// images\n$checkboxImageUrl: '../img/checkbox.png';\n\n// cards\n$card-background: linear-gradient(135deg, #2f2f2f, #262626);\n$card-background-hover: linear-gradient(135deg, #343434, #262626);\n$card-shadow: -1px -1px 0 0 hsla(0, 0%, 100%, .1), 1px 1px 0 0 rgba(0, 0, 0, .3);\n\n// footer\n$footer-link-color:   $gray-1;\n$footer-link-hover:   $gray-4;\n"],sourceRoot:""}]);const u=a},208:(n,t,e)=>{e.d(t,{A:()=>u});var r=e(942),o=e.n(r),i=e(278),a=e.n(i)()(o());a.push([n.id,".axis path,.axis line{fill:none;stroke:#555;shape-rendering:crispEdges}.axis{font:10px sans-serif}.axis text{-webkit-transition:fill-opacity 250ms linear;color:#7b7b7b;fill:currentColor}.axis path{display:none}.axis line{stroke:#7b7b7b;shape-rendering:crispEdges}.horizon{border-bottom:solid 1px #7b7b7b;overflow:hidden;position:relative}.horizon{border-top:solid 1px #7b7b7b;border-bottom:solid 1px #7b7b7b}.horizon+.horizon{border-top:none}.horizon canvas{display:block}.horizon .title,.horizon .value{bottom:0;color:#555;line-height:30px;margin:0 6px;position:absolute;text-shadow:-1px -1px 0 #fff,1px -1px 0 #fff,-1px 1px 0 #fff,1px 1px 0 #fff;white-space:nowrap}.horizon .title{left:0}.horizon .value{right:0}.line{background:#555;z-index:2}.cubism-wrapper{width:100%}.cubism-canvas-wrapper{width:100%}.cubism-panel{position:relative;padding:0;width:100%}","",{version:3,sources:["webpack://./sass/cubism.scss","webpack://./sass/_variables.light.scss"],names:[],mappings:"AAGA,sBACC,SAAA,CACA,WCekB,CDdlB,0BAAA,CAGD,MACC,oBAAA,CAGD,WACC,4CAAA,CACA,aCMkB,CDLlB,iBAAA,CAID,WACC,YAAA,CAGD,WACC,cCJkB,CDKlB,0BAAA,CAMD,SACC,+BAAA,CACA,eAAA,CACA,iBAAA,CAGD,SACC,4BAAA,CACA,+BAAA,CAGD,kBACC,eAAA,CAGD,gBACC,aAAA,CAGD,gCAEC,QAAA,CACA,UClCkB,CDmClB,gBAAA,CACA,YAAA,CACA,iBAAA,CACA,2EAAA,CACA,kBAAA,CAGD,gBACC,MAAA,CAGD,gBACC,OAAA,CAMD,MACC,eCtDkB,CDwDlB,SAAA,CAMD,gBACE,UAAA,CAGF,uBACE,UAAA,CAGF,cACE,iBAAA,CACA,SAAA,CACA,UAAA",sourcesContent:["/*-----------------------------------------------------------------------------\nAXIS\n-----------------------------------------------------------------------------*/\n.axis path, .axis line {\n\tfill: none;\n\tstroke: $body-color;\n\tshape-rendering: crispEdges;\n}\n\n.axis {\n\tfont: 10px sans-serif\n}\n\n.axis text {\n\t-webkit-transition: fill-opacity 250ms linear;\n\tcolor: $text-color-weak;\n\tfill: currentColor;\n\n}\n\n.axis path {\n\tdisplay: none\n}\n\n.axis line {\n\tstroke: $text-color-weak;\n\tshape-rendering: crispEdges\n}\n\n/*-----------------------------------------------------------------------------\nHORIZON\n-----------------------------------------------------------------------------*/\n.horizon {\n\tborder-bottom: solid 1px $text-color-weak;\n\toverflow: hidden;\n\tposition: relative\n}\n\n.horizon {\n\tborder-top: solid 1px $text-color-weak;\n\tborder-bottom: solid 1px $text-color-weak\n}\n\n.horizon + .horizon {\n\tborder-top: none\n}\n\n.horizon canvas {\n\tdisplay: block\n}\n\n.horizon .title,\n.horizon .value {\n\tbottom: 0;\n\tcolor: $text-color;\n\tline-height: 30px;\n\tmargin: 0 6px;\n\tposition: absolute;\n\ttext-shadow: -1px -1px 0 $page-bg, 1px -1px 0 $page-bg, -1px 1px 0 $page-bg, 1px 1px 0 $page-bg;\n\twhite-space: nowrap\n}\n\n.horizon .title {\n\tleft: 0\n}\n\n.horizon .value {\n\tright: 0\n}\n\n/*-----------------------------------------------------------------------------\nMarker\n-----------------------------------------------------------------------------*/\n.line {\n\tbackground: $body-color;\n\t//opacity: .2;\n\tz-index: 2;\n}\n\n/*-----------------------------------------------------------------------------\nDIVS\n-----------------------------------------------------------------------------*/\n.cubism-wrapper {\n  width: 100%;\n}\n\n.cubism-canvas-wrapper {\n  width: 100%;\n}\n\n.cubism-panel {\n  position: relative;\n  padding: 0;\n  width: 100%;\n}\n","// Cosmo 2.3.2\n// Variables\n// --------------------------------------------------\n\n\n// Global values\n// --------------------------------------------------\n\n\n// Grays\n// -------------------------\n$black:                 #000;\n\n// -------------------------\n$black:            #000;\n$dark-1:           #141414;\n$dark-2:           #1f1d1d;\n$dark-3:           #292929;\n$dark-4:           #373737;\n$dark-5:           #444444;\n$gray-1:           #555555;\n$gray-2:           #7B7B7B;\n$gray-3:           #b3b3b3;\n$gray-4:           #D8D9DA;\n$gray-5:           #ECECEC;\n$gray-6:           #f4f5f8;\n$gray-7:           #fbfbfb;\n\n$white:            #fff;\n\n// Accent colors\n// -------------------------\n$blue:             \t   \t#2AB2E4;\n$blue-dark:             #3CAAD6;\n$green:                 #28B62C;\n$red:                   #FF4136;\n$yellow:                #FF851B;\n$orange:                #Ff7941;\n$pink:                  #E671B8;\n$purple:                #9954BB;\n$variable:              #2AB2E4;\n\n$brand-primary:         $orange;\n$brand-success:         $green;\n$brand-warning:         $orange;\n$brand-danger:          $red;\n$brand-text-highlight:  #f7941d;\n\n// Status colors\n// -------------------------\n$online:                #01A64F;\n$warn:                  #F79520;\n$critical:              #EC2128;\n\n// Scaffolding\n// -------------------------\n\n$body-bg:  \t\t  \t\t    $white;\n$page-bg:  \t\t  \t\t    $white;\n$body-color:    \t\t    $gray-1;\n$text-color:    \t\t    $gray-1;\n$text-color-strong:\t    $white;\n$text-color-weak: \t    $gray-2;\n$text-color-faint:      $gray-3;\n$text-color-emphasis: \t$dark-5;\n\n$text-shadow-strong: none;\n$text-shadow-faint: none;\n\n// gradients\n$brand-gradient: linear-gradient(to right, rgba(255,213,0,1.0) 0%, rgba(255,68,0,1.0) 99%, rgba(255,68,0,1.0) 100%);\n$page-gradient: linear-gradient(60deg, transparent 70%, darken($page-bg, 4%) 98%);\n\n// Links\n// -------------------------\n$link-color:             $gray-1;\n$link-color-disabled:    lighten($link-color, 30%);\n$link-hover-color:       darken($link-color, 20%);\n$external-link-color:    $blue;\n\n// Typography\n// -------------------------\n$headings-color:       $text-color;\n$abbr-border-color: \t $gray-2 !default;\n$text-muted: \t\t\t     $text-color-weak;\n\n$blockquote-small-color:  $gray-2 !default;\n$blockquote-border-color: $gray-3 !default;\n\n$hr-border-color: $dark-3 !default;\n\n// Components\n$component-active-color: $white !default;\n$component-active-bg:    $brand-primary !default;\n\n// Panel\n// -------------------------\n\n$panel-bg: \t\t  $gray-7;\n$panel-border:  solid 1px $gray-6;\n\n$divider-border-color:\t$gray-2;\n\n// Graphite Target Editor\n$tight-form-border:   $gray-4;\n$tight-form-bg:    \t\t$gray-6;\n\n$tight-form-func-bg:            $gray-5;\n$tight-form-func-highlight-bg:  $gray-6;\n\n$modal-background: $body-bg;\n$code-tag-bg:      $gray-6;\n$code-tag-border:  darken($code-tag-bg, 3%);\n\n// Lists\n$grafanaListBackground:    \t   $gray-6;\n$grafanaListAccent:            $gray-5;\n$grafanaListBorderTop:         $gray-3;\n$grafanaListBorderBottom:      $gray-3;\n$grafanaListHighlight:         $gray-5;\n$grafanaListMainLinkColor:     $text-color;\n\n\n// Tables\n// -------------------------\n$table-bg:                   transparent; // overall background-color\n$table-bg-accent:            $gray-5; // for striping\n$table-bg-hover:             $gray-5; // for hover\n$table-bg-active:            $table-bg-hover !default;\n$table-border:               $gray-3; // table and cell border\n\n// Scrollbars\n$scrollbarBackground:   $gray-5;\n$scrollbarBackground2:  $gray-5;\n$scrollbarBorder:       $gray-4;\n\n// Buttons\n// -------------------------\n$btn-primary-bg:        $brand-primary;\n$btn-primary-bg-hl:     lighten($brand-primary, 8%);\n\n$btn-secondary-bg:      $blue-dark;\n$btn-secondary-bg-hl:   lighten($blue-dark, 4%);\n\n$btn-success-bg:        lighten($green, 3%);\n$btn-success-bg-hl:     darken($green, 3%);\n\n$btn-warning-bg:        lighten($orange, 3%);\n$btn-warning-bg-hl:     darken($orange, 3%);\n\n$btn-danger-bg:         lighten($red, 3%);\n$btn-danger-bg-hl:      darken($red, 3%);\n\n$btn-inverse-bg:          $gray-5;\n$btn-inverse-bg-hl:       darken($gray-5, 5%);\n$btn-inverse-text-color:  $dark-4;\n\n$btn-link-color: $gray-1;\n\n$iconContainerBackground: $white;\n\n// Forms\n// -------------------------\n$input-bg:                       $gray-7;\n$input-bg-disabled:              $gray-5;\n\n$input-color:                    $dark-3;\n$input-border-color:             $gray-5;\n$input-box-shadow:               none;\n$input-border-focus:             $blue !default;\n$input-box-shadow-focus:         $blue !default;\n$input-color-placeholder:        $gray-4 !default;\n$input-label-bg:\t        \t     $gray-6;\n\n// Sidemenu\n// -------------------------\n$side-menu-bg:            $body-bg;\n$side-menu-item-hover-bg: $gray-6;\n$side-menu-opacity:\t\t  0.97;\n\n// search\n$search-shadow: 0 5px 30px 0 lighten($gray-2, 30%);\n\n// Dropdowns\n// -------------------------\n$dropdownBackground:            $white;\n$dropdownBorder:                $tight-form-border;\n$dropdownDividerTop:            $gray-6;\n$dropdownDividerBottom:         $white;\n$dropdownDivider:               $dropdownDividerTop;\n$dropdownTitle:                 $gray-3;\n\n$dropdownLinkColor:             $dark-3;\n$dropdownLinkColorHover:        $link-color;\n$dropdownLinkColorActive:       $link-color;\n\n$dropdownLinkBackgroundActive:  $gray-6;\n$dropdownLinkBackgroundHover:   $gray-6;\n\n\n// COMPONENT VARIABLES\n// --------------------------------------------------\n\n\n// Input placeholder text color\n// -------------------------\n$placeholderText:         $gray-2;\n\n\n// Hr border color\n// -------------------------\n$hrBorder:                $gray-3;\n\n\n// Horizontal forms & lists\n// -------------------------\n$horizontalComponentOffset:       180px;\n\n\n// Wells\n// -------------------------\n$wellBackground:                  $gray-3;\n\n\n// Navbar\n// -------------------------\n\n$navbarHeight:                    52px;\n$navbarBackgroundHighlight:       #f8f8f8;\n$navbarBackground:                #f8f8f8;\n$navbarBorder:                    1px solid $tight-form-border;\n\n$navbarText:                      #666;\n$navbarLinkColor:                 #666;\n$navbarLinkColorHover:            #333;\n$navbarLinkColorActive:           #555;\n$navbarLinkBackgroundHover:       transparent;\n$navbarLinkBackgroundActive:      darken($navbarBackground, 6.5%);\n$navbarDropdownShadow:            inset 0px 4px 7px -4px darken($body-bg, 20%);\n\n$navbarBrandColor:                $navbarLinkColor;\n\n$navbarButtonBackground:          lighten($navbarBackground, 3%);\n$navbarButtonBackgroundHighlight: lighten($navbarBackground, 5%);\n\n\n// Pagination\n// -------------------------\n$paginationBackground:                $gray-2;\n$paginationBorder:                    transparent;\n$paginationActiveBackground:          $blue;\n\n\n// Form states and alerts\n// -------------------------\n$state-warning-text:             lighten($orange, 10%);\n$state-warning-bg:       $orange;\n$warningBorder:           transparent;\n\n$errorText:               lighten($red, 10%);\n$errorBackground:         $red;\n$errorBorder:             transparent;\n\n$successText:             lighten($green, 10%);\n$successBackground:       $green;\n$successBorder:           transparent;\n\n$infoText:                $blue;\n$infoBackground:          $blue-dark;\n$infoBorder:              transparent;\n\n// popover\n$popover-bg:              $gray-5;\n$popover-color:           $text-color;\n\n$popover-help-bg:         $blue-dark;\n$popover-help-color:      $gray-6;\n\n// Tooltips and popovers\n// -------------------------\n$tooltipColor:            $popover-help-color;\n$tooltipBackground:       $popover-help-bg;\n$tooltipArrowWidth:       5px;\n$tooltipArrowColor:       $tooltipBackground;\n$tooltipLinkColor:        lighten($popover-help-color, 5%);\n$graph-tooltip-bg:        $gray-5;\n\n// images\n$checkboxImageUrl: '../img/checkbox_white.png';\n\n// cards\n$card-background: linear-gradient(135deg, $gray-5, $gray-6);\n$card-background-hover: linear-gradient(135deg, $gray-6, $gray-7);\n$card-shadow: -1px -1px 0 0 hsla(0, 0%, 100%, .1), 1px 1px 0 0 rgba(0, 0, 0, .1);\n\n// footer\n$footer-link-color:   $gray-3;\n$footer-link-hover:   $dark-5;\n"],sourceRoot:""}]);const u=a},278:n=>{n.exports=function(n){var t=[];return t.toString=function(){return this.map((function(t){var e="",r=void 0!==t[5];return t[4]&&(e+="@supports (".concat(t[4],") {")),t[2]&&(e+="@media ".concat(t[2]," {")),r&&(e+="@layer".concat(t[5].length>0?" ".concat(t[5]):""," {")),e+=n(t),r&&(e+="}"),t[2]&&(e+="}"),t[4]&&(e+="}"),e})).join("")},t.i=function(n,e,r,o,i){"string"==typeof n&&(n=[[null,n,void 0]]);var a={};if(r)for(var u=0;u<this.length;u++){var l=this[u][0];null!=l&&(a[l]=!0)}for(var c=0;c<n.length;c++){var s=[].concat(n[c]);r&&a[s[0]]||(void 0!==i&&(void 0===s[5]||(s[1]="@layer".concat(s[5].length>0?" ".concat(s[5]):""," {").concat(s[1],"}")),s[5]=i),e&&(s[2]?(s[1]="@media ".concat(s[2]," {").concat(s[1],"}"),s[2]=e):s[2]=e),o&&(s[4]?(s[1]="@supports (".concat(s[4],") {").concat(s[1],"}"),s[4]=o):s[4]="".concat(o)),t.push(s))}},t}},942:n=>{n.exports=function(n){var t=n[1],e=n[3];if(!e)return t;if("function"==typeof btoa){var r=btoa(unescape(encodeURIComponent(JSON.stringify(e)))),o="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(r),i="/*# ".concat(o," */");return[t].concat([i]).join("\n")}return[t].join("\n")}},569:(n,t,e)=>{e.r(t),e.d(t,{default:()=>m});var r=e(292),o=e.n(r),i=e(893),a=e.n(i),u=e(383),l=e.n(u),c=e(884),s=e.n(c),f=e(88),h=e.n(f),g=e(997),d=e.n(g),p=e(248),v={};v.styleTagTransform=d(),v.setAttributes=s(),v.insert=l().bind(null,"head"),v.domAPI=a(),v.insertStyleElement=h(),o()(p.A,v);const m=p.A&&p.A.locals?p.A.locals:void 0},303:(n,t,e)=>{e.r(t),e.d(t,{default:()=>m});var r=e(292),o=e.n(r),i=e(893),a=e.n(i),u=e(383),l=e.n(u),c=e(884),s=e.n(c),f=e(88),h=e.n(f),g=e(997),d=e.n(g),p=e(208),v={};v.styleTagTransform=d(),v.setAttributes=s(),v.insert=l().bind(null,"head"),v.domAPI=a(),v.insertStyleElement=h(),o()(p.A,v);const m=p.A&&p.A.locals?p.A.locals:void 0},292:n=>{var t=[];function e(n){for(var e=-1,r=0;r<t.length;r++)if(t[r].identifier===n){e=r;break}return e}function r(n,r){for(var i={},a=[],u=0;u<n.length;u++){var l=n[u],c=r.base?l[0]+r.base:l[0],s=i[c]||0,f="".concat(c," ").concat(s);i[c]=s+1;var h=e(f),g={css:l[1],media:l[2],sourceMap:l[3],supports:l[4],layer:l[5]};if(-1!==h)t[h].references++,t[h].updater(g);else{var d=o(g,r);r.byIndex=u,t.splice(u,0,{identifier:f,updater:d,references:1})}a.push(f)}return a}function o(n,t){var e=t.domAPI(t);return e.update(n),function(t){if(t){if(t.css===n.css&&t.media===n.media&&t.sourceMap===n.sourceMap&&t.supports===n.supports&&t.layer===n.layer)return;e.update(n=t)}else e.remove()}}n.exports=function(n,o){var i=r(n=n||[],o=o||{});return function(n){n=n||[];for(var a=0;a<i.length;a++){var u=e(i[a]);t[u].references--}for(var l=r(n,o),c=0;c<i.length;c++){var s=e(i[c]);0===t[s].references&&(t[s].updater(),t.splice(s,1))}i=l}}},383:n=>{var t={};n.exports=function(n,e){var r=function(n){if(void 0===t[n]){var e=document.querySelector(n);if(window.HTMLIFrameElement&&e instanceof window.HTMLIFrameElement)try{e=e.contentDocument.head}catch(n){e=null}t[n]=e}return t[n]}(n);if(!r)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");r.appendChild(e)}},88:n=>{n.exports=function(n){var t=document.createElement("style");return n.setAttributes(t,n.attributes),n.insert(t,n.options),t}},884:(n,t,e)=>{n.exports=function(n){var t=e.nc;t&&n.setAttribute("nonce",t)}},893:n=>{n.exports=function(n){if("undefined"==typeof document)return{update:function(){},remove:function(){}};var t=n.insertStyleElement(n);return{update:function(e){!function(n,t,e){var r="";e.supports&&(r+="@supports (".concat(e.supports,") {")),e.media&&(r+="@media ".concat(e.media," {"));var o=void 0!==e.layer;o&&(r+="@layer".concat(e.layer.length>0?" ".concat(e.layer):""," {")),r+=e.css,o&&(r+="}"),e.media&&(r+="}"),e.supports&&(r+="}");var i=e.sourceMap;i&&"undefined"!=typeof btoa&&(r+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(i))))," */")),t.styleTagTransform(r,n,t.options)}(t,n,e)},remove:function(){!function(n){if(null===n.parentNode)return!1;n.parentNode.removeChild(n)}(t)}}}},997:n=>{n.exports=function(n,t){if(t.styleSheet)t.styleSheet.cssText=n;else{for(;t.firstChild;)t.removeChild(t.firstChild);t.appendChild(document.createTextNode(n))}}},89:n=>{n.exports=e},781:t=>{t.exports=n},531:n=>{n.exports=i},7:n=>{n.exports=r},201:n=>{n.exports=o},241:n=>{n.exports=a},959:n=>{n.exports=t}},l={};function c(n){var t=l[n];if(void 0!==t)return t.exports;var e=l[n]={id:n,exports:{}};return u[n](e,e.exports,c),e.exports}c.n=n=>{var t=n&&n.__esModule?()=>n.default:()=>n;return c.d(t,{a:t}),t},c.d=(n,t)=>{for(var e in t)c.o(t,e)&&!c.o(n,e)&&Object.defineProperty(n,e,{enumerable:!0,get:t[e]})},c.o=(n,t)=>Object.prototype.hasOwnProperty.call(n,t),c.r=n=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},c.nc=void 0;var s={};return(()=>{c.r(s),c.d(s,{plugin:()=>ru});var n=c(781),t=c(959),e=c.n(t),r=c(89),o=c(7),i=c(201),a={value:()=>{}};function u(){for(var n,t=0,e=arguments.length,r={};t<e;++t){if(!(n=arguments[t]+"")||n in r||/[\s.]/.test(n))throw new Error("illegal type: "+n);r[n]=[]}return new l(r)}function l(n){this._=n}function f(n,t){for(var e,r=0,o=n.length;r<o;++r)if((e=n[r]).name===t)return e.value}function h(n,t,e){for(var r=0,o=n.length;r<o;++r)if(n[r].name===t){n[r]=a,n=n.slice(0,r).concat(n.slice(r+1));break}return null!=e&&n.push({name:t,value:e}),n}function g(n,t){return null==n||null==t?NaN:n<t?-1:n>t?1:n>=t?0:NaN}function d(n,t){return null==n||null==t?NaN:t<n?-1:t>n?1:t>=n?0:NaN}function p(n){let t,e,r;function o(n,r,o=0,i=n.length){if(o<i){if(0!==t(r,r))return i;do{const t=o+i>>>1;e(n[t],r)<0?o=t+1:i=t}while(o<i)}return o}return 2!==n.length?(t=g,e=(t,e)=>g(n(t),e),r=(t,e)=>n(t)-e):(t=n===g||n===d?n:v,e=n,r=n),{left:o,center:function(n,t,e=0,i=n.length){const a=o(n,t,e,i-1);return a>e&&r(n[a-1],t)>-r(n[a],t)?a-1:a},right:function(n,r,o=0,i=n.length){if(o<i){if(0!==t(r,r))return i;do{const t=o+i>>>1;e(n[t],r)<=0?o=t+1:i=t}while(o<i)}return o}}}function v(){return 0}l.prototype=u.prototype={constructor:l,on:function(n,t){var e,r,o=this._,i=(r=o,(n+"").trim().split(/^|\s+/).map((function(n){var t="",e=n.indexOf(".");if(e>=0&&(t=n.slice(e+1),n=n.slice(0,e)),n&&!r.hasOwnProperty(n))throw new Error("unknown type: "+n);return{type:n,name:t}}))),a=-1,u=i.length;if(!(arguments.length<2)){if(null!=t&&"function"!=typeof t)throw new Error("invalid callback: "+t);for(;++a<u;)if(e=(n=i[a]).type)o[e]=h(o[e],n.name,t);else if(null==t)for(e in o)o[e]=h(o[e],n.name,null);return this}for(;++a<u;)if((e=(n=i[a]).type)&&(e=f(o[e],n.name)))return e},copy:function(){var n={},t=this._;for(var e in t)n[e]=t[e].slice();return new l(n)},call:function(n,t){if((e=arguments.length-2)>0)for(var e,r,o=new Array(e),i=0;i<e;++i)o[i]=arguments[i+2];if(!this._.hasOwnProperty(n))throw new Error("unknown type: "+n);for(i=0,e=(r=this._[n]).length;i<e;++i)r[i].value.apply(t,o)},apply:function(n,t,e){if(!this._.hasOwnProperty(n))throw new Error("unknown type: "+n);for(var r=this._[n],o=0,i=r.length;o<i;++o)r[o].value.apply(t,e)}};const m=p(g).right;p((function(n){return null===n?NaN:+n})).center;const b=Math.sqrt(50),y=Math.sqrt(10),$=Math.sqrt(2);function x(n,t,e){const r=(t-n)/Math.max(0,e),o=Math.floor(Math.log10(r)),i=r/Math.pow(10,o),a=i>=b?10:i>=y?5:i>=$?2:1;let u,l,c;return o<0?(c=Math.pow(10,-o)/a,u=Math.round(n*c),l=Math.round(t*c),u/c<n&&++u,l/c>t&&--l,c=-c):(c=Math.pow(10,o)*a,u=Math.round(n/c),l=Math.round(t/c),u*c<n&&++u,l*c>t&&--l),l<u&&.5<=e&&e<2?x(n,t,2*e):[u,l,c]}function w(n,t,e){return x(n=+n,t=+t,e=+e)[2]}function A(n,t,e){e=+e;const r=(t=+t)<(n=+n),o=r?w(t,n,e):w(n,t,e);return(r?-1:1)*(o<0?1/-o:o)}function C(n,t){switch(arguments.length){case 0:break;case 1:this.range(n);break;default:this.range(t).domain(n)}return this}function _(n,t,e){n.prototype=t.prototype=e,e.constructor=n}function k(n,t){var e=Object.create(n.prototype);for(var r in t)e[r]=t[r];return e}function M(){}var D=.7,T=1/D,B="\\s*([+-]?\\d+)\\s*",S="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",U="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",N=/^#([0-9a-f]{3,8})$/,F=new RegExp(`^rgb\\(${B},${B},${B}\\)$`),z=new RegExp(`^rgb\\(${U},${U},${U}\\)$`),L=new RegExp(`^rgba\\(${B},${B},${B},${S}\\)$`),E=new RegExp(`^rgba\\(${U},${U},${U},${S}\\)$`),H=new RegExp(`^hsl\\(${S},${U},${U}\\)$`),Y=new RegExp(`^hsla\\(${S},${U},${U},${S}\\)$`),O={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function I(){return this.rgb().formatHex()}function j(){return this.rgb().formatRgb()}function P(n){var t,e;return n=(n+"").trim().toLowerCase(),(t=N.exec(n))?(e=t[1].length,t=parseInt(t[1],16),6===e?R(t):3===e?new W(t>>8&15|t>>4&240,t>>4&15|240&t,(15&t)<<4|15&t,1):8===e?q(t>>24&255,t>>16&255,t>>8&255,(255&t)/255):4===e?q(t>>12&15|t>>8&240,t>>8&15|t>>4&240,t>>4&15|240&t,((15&t)<<4|15&t)/255):null):(t=F.exec(n))?new W(t[1],t[2],t[3],1):(t=z.exec(n))?new W(255*t[1]/100,255*t[2]/100,255*t[3]/100,1):(t=L.exec(n))?q(t[1],t[2],t[3],t[4]):(t=E.exec(n))?q(255*t[1]/100,255*t[2]/100,255*t[3]/100,t[4]):(t=H.exec(n))?K(t[1],t[2]/100,t[3]/100,1):(t=Y.exec(n))?K(t[1],t[2]/100,t[3]/100,t[4]):O.hasOwnProperty(n)?R(O[n]):"transparent"===n?new W(NaN,NaN,NaN,0):null}function R(n){return new W(n>>16&255,n>>8&255,255&n,1)}function q(n,t,e,r){return r<=0&&(n=t=e=NaN),new W(n,t,e,r)}function G(n,t,e,r){return 1===arguments.length?((o=n)instanceof M||(o=P(o)),o?new W((o=o.rgb()).r,o.g,o.b,o.opacity):new W):new W(n,t,e,null==r?1:r);var o}function W(n,t,e,r){this.r=+n,this.g=+t,this.b=+e,this.opacity=+r}function V(){return`#${Q(this.r)}${Q(this.g)}${Q(this.b)}`}function Z(){const n=X(this.opacity);return`${1===n?"rgb(":"rgba("}${J(this.r)}, ${J(this.g)}, ${J(this.b)}${1===n?")":`, ${n})`}`}function X(n){return isNaN(n)?1:Math.max(0,Math.min(1,n))}function J(n){return Math.max(0,Math.min(255,Math.round(n)||0))}function Q(n){return((n=J(n))<16?"0":"")+n.toString(16)}function K(n,t,e,r){return r<=0?n=t=e=NaN:e<=0||e>=1?n=t=NaN:t<=0&&(n=NaN),new tn(n,t,e,r)}function nn(n){if(n instanceof tn)return new tn(n.h,n.s,n.l,n.opacity);if(n instanceof M||(n=P(n)),!n)return new tn;if(n instanceof tn)return n;var t=(n=n.rgb()).r/255,e=n.g/255,r=n.b/255,o=Math.min(t,e,r),i=Math.max(t,e,r),a=NaN,u=i-o,l=(i+o)/2;return u?(a=t===i?(e-r)/u+6*(e<r):e===i?(r-t)/u+2:(t-e)/u+4,u/=l<.5?i+o:2-i-o,a*=60):u=l>0&&l<1?0:a,new tn(a,u,l,n.opacity)}function tn(n,t,e,r){this.h=+n,this.s=+t,this.l=+e,this.opacity=+r}function en(n){return(n=(n||0)%360)<0?n+360:n}function rn(n){return Math.max(0,Math.min(1,n||0))}function on(n,t,e){return 255*(n<60?t+(e-t)*n/60:n<180?e:n<240?t+(e-t)*(240-n)/60:t)}_(M,P,{copy(n){return Object.assign(new this.constructor,this,n)},displayable(){return this.rgb().displayable()},hex:I,formatHex:I,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return nn(this).formatHsl()},formatRgb:j,toString:j}),_(W,G,k(M,{brighter(n){return n=null==n?T:Math.pow(T,n),new W(this.r*n,this.g*n,this.b*n,this.opacity)},darker(n){return n=null==n?D:Math.pow(D,n),new W(this.r*n,this.g*n,this.b*n,this.opacity)},rgb(){return this},clamp(){return new W(J(this.r),J(this.g),J(this.b),X(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:V,formatHex:V,formatHex8:function(){return`#${Q(this.r)}${Q(this.g)}${Q(this.b)}${Q(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:Z,toString:Z})),_(tn,(function(n,t,e,r){return 1===arguments.length?nn(n):new tn(n,t,e,null==r?1:r)}),k(M,{brighter(n){return n=null==n?T:Math.pow(T,n),new tn(this.h,this.s,this.l*n,this.opacity)},darker(n){return n=null==n?D:Math.pow(D,n),new tn(this.h,this.s,this.l*n,this.opacity)},rgb(){var n=this.h%360+360*(this.h<0),t=isNaN(n)||isNaN(this.s)?0:this.s,e=this.l,r=e+(e<.5?e:1-e)*t,o=2*e-r;return new W(on(n>=240?n-240:n+120,o,r),on(n,o,r),on(n<120?n+240:n-120,o,r),this.opacity)},clamp(){return new tn(en(this.h),rn(this.s),rn(this.l),X(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const n=X(this.opacity);return`${1===n?"hsl(":"hsla("}${en(this.h)}, ${100*rn(this.s)}%, ${100*rn(this.l)}%${1===n?")":`, ${n})`}`}}));var an=n=>()=>n;function un(n,t){var e=t-n;return e?function(n,t){return function(e){return n+e*t}}(n,e):an(isNaN(n)?t:n)}var ln=function n(t){var e=function(n){return 1==(n=+n)?un:function(t,e){return e-t?function(n,t,e){return n=Math.pow(n,e),t=Math.pow(t,e)-n,e=1/e,function(r){return Math.pow(n+r*t,e)}}(t,e,n):an(isNaN(t)?e:t)}}(t);function r(n,t){var r=e((n=G(n)).r,(t=G(t)).r),o=e(n.g,t.g),i=e(n.b,t.b),a=un(n.opacity,t.opacity);return function(t){return n.r=r(t),n.g=o(t),n.b=i(t),n.opacity=a(t),n+""}}return r.gamma=n,r}(1);function cn(n,t){t||(t=[]);var e,r=n?Math.min(t.length,n.length):0,o=t.slice();return function(i){for(e=0;e<r;++e)o[e]=n[e]*(1-i)+t[e]*i;return o}}function sn(n,t){var e,r=t?t.length:0,o=n?Math.min(r,n.length):0,i=new Array(o),a=new Array(r);for(e=0;e<o;++e)i[e]=mn(n[e],t[e]);for(;e<r;++e)a[e]=t[e];return function(n){for(e=0;e<o;++e)a[e]=i[e](n);return a}}function fn(n,t){var e=new Date;return n=+n,t=+t,function(r){return e.setTime(n*(1-r)+t*r),e}}function hn(n,t){return n=+n,t=+t,function(e){return n*(1-e)+t*e}}function gn(n,t){var e,r={},o={};for(e in null!==n&&"object"==typeof n||(n={}),null!==t&&"object"==typeof t||(t={}),t)e in n?r[e]=mn(n[e],t[e]):o[e]=t[e];return function(n){for(e in r)o[e]=r[e](n);return o}}var dn=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,pn=new RegExp(dn.source,"g");function vn(n,t){var e,r,o,i=dn.lastIndex=pn.lastIndex=0,a=-1,u=[],l=[];for(n+="",t+="";(e=dn.exec(n))&&(r=pn.exec(t));)(o=r.index)>i&&(o=t.slice(i,o),u[a]?u[a]+=o:u[++a]=o),(e=e[0])===(r=r[0])?u[a]?u[a]+=r:u[++a]=r:(u[++a]=null,l.push({i:a,x:hn(e,r)})),i=pn.lastIndex;return i<t.length&&(o=t.slice(i),u[a]?u[a]+=o:u[++a]=o),u.length<2?l[0]?function(n){return function(t){return n(t)+""}}(l[0].x):function(n){return function(){return n}}(t):(t=l.length,function(n){for(var e,r=0;r<t;++r)u[(e=l[r]).i]=e.x(n);return u.join("")})}function mn(n,t){var e,r,o=typeof t;return null==t||"boolean"===o?an(t):("number"===o?hn:"string"===o?(e=P(t))?(t=e,ln):vn:t instanceof P?ln:t instanceof Date?fn:(r=t,!ArrayBuffer.isView(r)||r instanceof DataView?Array.isArray(t)?sn:"function"!=typeof t.valueOf&&"function"!=typeof t.toString||isNaN(t)?gn:hn:cn))(n,t)}function bn(n,t){return n=+n,t=+t,function(e){return Math.round(n*(1-e)+t*e)}}function yn(n){return+n}var $n=[0,1];function xn(n){return n}function wn(n,t){return(t-=n=+n)?function(e){return(e-n)/t}:(e=isNaN(t)?NaN:.5,function(){return e});var e}function An(n,t,e){var r=n[0],o=n[1],i=t[0],a=t[1];return o<r?(r=wn(o,r),i=e(a,i)):(r=wn(r,o),i=e(i,a)),function(n){return i(r(n))}}function Cn(n,t,e){var r=Math.min(n.length,t.length)-1,o=new Array(r),i=new Array(r),a=-1;for(n[r]<n[0]&&(n=n.slice().reverse(),t=t.slice().reverse());++a<r;)o[a]=wn(n[a],n[a+1]),i[a]=e(t[a],t[a+1]);return function(t){var e=m(n,t,1,r)-1;return i[e](o[e](t))}}function _n(n,t){return t.domain(n.domain()).range(n.range()).interpolate(n.interpolate()).clamp(n.clamp()).unknown(n.unknown())}function kn(){return function(){var n,t,e,r,o,i,a=$n,u=$n,l=mn,c=xn;function s(){var n,t,e,l=Math.min(a.length,u.length);return c!==xn&&(n=a[0],t=a[l-1],n>t&&(e=n,n=t,t=e),c=function(e){return Math.max(n,Math.min(t,e))}),r=l>2?Cn:An,o=i=null,f}function f(t){return null==t||isNaN(t=+t)?e:(o||(o=r(a.map(n),u,l)))(n(c(t)))}return f.invert=function(e){return c(t((i||(i=r(u,a.map(n),hn)))(e)))},f.domain=function(n){return arguments.length?(a=Array.from(n,yn),s()):a.slice()},f.range=function(n){return arguments.length?(u=Array.from(n),s()):u.slice()},f.rangeRound=function(n){return u=Array.from(n),l=bn,s()},f.clamp=function(n){return arguments.length?(c=!!n||xn,s()):c!==xn},f.interpolate=function(n){return arguments.length?(l=n,s()):l},f.unknown=function(n){return arguments.length?(e=n,f):e},function(e,r){return n=e,t=r,s()}}()(xn,xn)}function Mn(n,t){if((e=(n=t?n.toExponential(t-1):n.toExponential()).indexOf("e"))<0)return null;var e,r=n.slice(0,e);return[r.length>1?r[0]+r.slice(2):r,+n.slice(e+1)]}function Dn(n){return(n=Mn(Math.abs(n)))?n[1]:NaN}var Tn,Bn=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function Sn(n){if(!(t=Bn.exec(n)))throw new Error("invalid format: "+n);var t;return new Un({fill:t[1],align:t[2],sign:t[3],symbol:t[4],zero:t[5],width:t[6],comma:t[7],precision:t[8]&&t[8].slice(1),trim:t[9],type:t[10]})}function Un(n){this.fill=void 0===n.fill?" ":n.fill+"",this.align=void 0===n.align?">":n.align+"",this.sign=void 0===n.sign?"-":n.sign+"",this.symbol=void 0===n.symbol?"":n.symbol+"",this.zero=!!n.zero,this.width=void 0===n.width?void 0:+n.width,this.comma=!!n.comma,this.precision=void 0===n.precision?void 0:+n.precision,this.trim=!!n.trim,this.type=void 0===n.type?"":n.type+""}function Nn(n,t){var e=Mn(n,t);if(!e)return n+"";var r=e[0],o=e[1];return o<0?"0."+new Array(-o).join("0")+r:r.length>o+1?r.slice(0,o+1)+"."+r.slice(o+1):r+new Array(o-r.length+2).join("0")}Sn.prototype=Un.prototype,Un.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};var Fn={"%":(n,t)=>(100*n).toFixed(t),b:n=>Math.round(n).toString(2),c:n=>n+"",d:function(n){return Math.abs(n=Math.round(n))>=1e21?n.toLocaleString("en").replace(/,/g,""):n.toString(10)},e:(n,t)=>n.toExponential(t),f:(n,t)=>n.toFixed(t),g:(n,t)=>n.toPrecision(t),o:n=>Math.round(n).toString(8),p:(n,t)=>Nn(100*n,t),r:Nn,s:function(n,t){var e=Mn(n,t);if(!e)return n+"";var r=e[0],o=e[1],i=o-(Tn=3*Math.max(-8,Math.min(8,Math.floor(o/3))))+1,a=r.length;return i===a?r:i>a?r+new Array(i-a+1).join("0"):i>0?r.slice(0,i)+"."+r.slice(i):"0."+new Array(1-i).join("0")+Mn(n,Math.max(0,t+i-1))[0]},X:n=>Math.round(n).toString(16).toUpperCase(),x:n=>Math.round(n).toString(16)};function zn(n){return n}var Ln,En,Hn,Yn=Array.prototype.map,On=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function In(n){var t=n.domain;return n.ticks=function(n){var e=t();return function(n,t,e){if(!((e=+e)>0))return[];if((n=+n)==(t=+t))return[n];const r=t<n,[o,i,a]=r?x(t,n,e):x(n,t,e);if(!(i>=o))return[];const u=i-o+1,l=new Array(u);if(r)if(a<0)for(let n=0;n<u;++n)l[n]=(i-n)/-a;else for(let n=0;n<u;++n)l[n]=(i-n)*a;else if(a<0)for(let n=0;n<u;++n)l[n]=(o+n)/-a;else for(let n=0;n<u;++n)l[n]=(o+n)*a;return l}(e[0],e[e.length-1],null==n?10:n)},n.tickFormat=function(n,e){var r=t();return function(n,t,e,r){var o,i=A(n,t,e);switch((r=Sn(null==r?",f":r)).type){case"s":var a=Math.max(Math.abs(n),Math.abs(t));return null!=r.precision||isNaN(o=function(n,t){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(Dn(t)/3)))-Dn(Math.abs(n)))}(i,a))||(r.precision=o),Hn(r,a);case"":case"e":case"g":case"p":case"r":null!=r.precision||isNaN(o=function(n,t){return n=Math.abs(n),t=Math.abs(t)-n,Math.max(0,Dn(t)-Dn(n))+1}(i,Math.max(Math.abs(n),Math.abs(t))))||(r.precision=o-("e"===r.type));break;case"f":case"%":null!=r.precision||isNaN(o=function(n){return Math.max(0,-Dn(Math.abs(n)))}(i))||(r.precision=o-2*("%"===r.type))}return En(r)}(r[0],r[r.length-1],null==n?10:n,e)},n.nice=function(e){null==e&&(e=10);var r,o,i=t(),a=0,u=i.length-1,l=i[a],c=i[u],s=10;for(c<l&&(o=l,l=c,c=o,o=a,a=u,u=o);s-- >0;){if((o=w(l,c,e))===r)return i[a]=l,i[u]=c,t(i);if(o>0)l=Math.floor(l/o)*o,c=Math.ceil(c/o)*o;else{if(!(o<0))break;l=Math.ceil(l*o)/o,c=Math.floor(c*o)/o}r=o}return n},n}function jn(){var n=kn();return n.copy=function(){return _n(n,jn())},C.apply(n,arguments),In(n)}Ln=function(n){var t,e,r=void 0===n.grouping||void 0===n.thousands?zn:(t=Yn.call(n.grouping,Number),e=n.thousands+"",function(n,r){for(var o=n.length,i=[],a=0,u=t[0],l=0;o>0&&u>0&&(l+u+1>r&&(u=Math.max(1,r-l)),i.push(n.substring(o-=u,o+u)),!((l+=u+1)>r));)u=t[a=(a+1)%t.length];return i.reverse().join(e)}),o=void 0===n.currency?"":n.currency[0]+"",i=void 0===n.currency?"":n.currency[1]+"",a=void 0===n.decimal?".":n.decimal+"",u=void 0===n.numerals?zn:function(n){return function(t){return t.replace(/[0-9]/g,(function(t){return n[+t]}))}}(Yn.call(n.numerals,String)),l=void 0===n.percent?"%":n.percent+"",c=void 0===n.minus?"−":n.minus+"",s=void 0===n.nan?"NaN":n.nan+"";function f(n){var t=(n=Sn(n)).fill,e=n.align,f=n.sign,h=n.symbol,g=n.zero,d=n.width,p=n.comma,v=n.precision,m=n.trim,b=n.type;"n"===b?(p=!0,b="g"):Fn[b]||(void 0===v&&(v=12),m=!0,b="g"),(g||"0"===t&&"="===e)&&(g=!0,t="0",e="=");var y="$"===h?o:"#"===h&&/[boxX]/.test(b)?"0"+b.toLowerCase():"",$="$"===h?i:/[%p]/.test(b)?l:"",x=Fn[b],w=/[defgprs%]/.test(b);function A(n){var o,i,l,h=y,A=$;if("c"===b)A=x(n)+A,n="";else{var C=(n=+n)<0||1/n<0;if(n=isNaN(n)?s:x(Math.abs(n),v),m&&(n=function(n){n:for(var t,e=n.length,r=1,o=-1;r<e;++r)switch(n[r]){case".":o=t=r;break;case"0":0===o&&(o=r),t=r;break;default:if(!+n[r])break n;o>0&&(o=0)}return o>0?n.slice(0,o)+n.slice(t+1):n}(n)),C&&0==+n&&"+"!==f&&(C=!1),h=(C?"("===f?f:c:"-"===f||"("===f?"":f)+h,A=("s"===b?On[8+Tn/3]:"")+A+(C&&"("===f?")":""),w)for(o=-1,i=n.length;++o<i;)if(48>(l=n.charCodeAt(o))||l>57){A=(46===l?a+n.slice(o+1):n.slice(o))+A,n=n.slice(0,o);break}}p&&!g&&(n=r(n,1/0));var _=h.length+n.length+A.length,k=_<d?new Array(d-_+1).join(t):"";switch(p&&g&&(n=r(k+n,k.length?d-A.length:1/0),k=""),e){case"<":n=h+n+A+k;break;case"=":n=h+k+n+A;break;case"^":n=k.slice(0,_=k.length>>1)+h+n+A+k.slice(_);break;default:n=k+h+n+A}return u(n)}return v=void 0===v?6:/[gprs]/.test(b)?Math.max(1,Math.min(21,v)):Math.max(0,Math.min(20,v)),A.toString=function(){return n+""},A}return{format:f,formatPrefix:function(n,t){var e=f(((n=Sn(n)).type="f",n)),r=3*Math.max(-8,Math.min(8,Math.floor(Dn(t)/3))),o=Math.pow(10,-r),i=On[8+r/3];return function(n){return e(o*n)+i}}}}({thousands:",",grouping:[3],currency:["$",""]}),En=Ln.format,Hn=Ln.formatPrefix;const Pn=new Date,Rn=new Date;function qn(n,t,e,r){function o(t){return n(t=0===arguments.length?new Date:new Date(+t)),t}return o.floor=t=>(n(t=new Date(+t)),t),o.ceil=e=>(n(e=new Date(e-1)),t(e,1),n(e),e),o.round=n=>{const t=o(n),e=o.ceil(n);return n-t<e-n?t:e},o.offset=(n,e)=>(t(n=new Date(+n),null==e?1:Math.floor(e)),n),o.range=(e,r,i)=>{const a=[];if(e=o.ceil(e),i=null==i?1:Math.floor(i),!(e<r&&i>0))return a;let u;do{a.push(u=new Date(+e)),t(e,i),n(e)}while(u<e&&e<r);return a},o.filter=e=>qn((t=>{if(t>=t)for(;n(t),!e(t);)t.setTime(t-1)}),((n,r)=>{if(n>=n)if(r<0)for(;++r<=0;)for(;t(n,-1),!e(n););else for(;--r>=0;)for(;t(n,1),!e(n););})),e&&(o.count=(t,r)=>(Pn.setTime(+t),Rn.setTime(+r),n(Pn),n(Rn),Math.floor(e(Pn,Rn))),o.every=n=>(n=Math.floor(n),isFinite(n)&&n>0?n>1?o.filter(r?t=>r(t)%n==0:t=>o.count(0,t)%n==0):o:null)),o}const Gn=qn((()=>{}),((n,t)=>{n.setTime(+n+t)}),((n,t)=>t-n));Gn.every=n=>(n=Math.floor(n),isFinite(n)&&n>0?n>1?qn((t=>{t.setTime(Math.floor(t/n)*n)}),((t,e)=>{t.setTime(+t+e*n)}),((t,e)=>(e-t)/n)):Gn:null),Gn.range;const Wn=1e3,Vn=6e4,Zn=36e5,Xn=864e5,Jn=6048e5,Qn=31536e6,Kn=qn((n=>{n.setTime(n-n.getMilliseconds())}),((n,t)=>{n.setTime(+n+t*Wn)}),((n,t)=>(t-n)/Wn),(n=>n.getUTCSeconds()));Kn.range;const nt=qn((n=>{n.setTime(n-n.getMilliseconds()-n.getSeconds()*Wn)}),((n,t)=>{n.setTime(+n+t*Vn)}),((n,t)=>(t-n)/Vn),(n=>n.getMinutes()));nt.range;const tt=qn((n=>{n.setUTCSeconds(0,0)}),((n,t)=>{n.setTime(+n+t*Vn)}),((n,t)=>(t-n)/Vn),(n=>n.getUTCMinutes()));tt.range;const et=qn((n=>{n.setTime(n-n.getMilliseconds()-n.getSeconds()*Wn-n.getMinutes()*Vn)}),((n,t)=>{n.setTime(+n+t*Zn)}),((n,t)=>(t-n)/Zn),(n=>n.getHours()));et.range;const rt=qn((n=>{n.setUTCMinutes(0,0,0)}),((n,t)=>{n.setTime(+n+t*Zn)}),((n,t)=>(t-n)/Zn),(n=>n.getUTCHours()));rt.range;const ot=qn((n=>n.setHours(0,0,0,0)),((n,t)=>n.setDate(n.getDate()+t)),((n,t)=>(t-n-(t.getTimezoneOffset()-n.getTimezoneOffset())*Vn)/Xn),(n=>n.getDate()-1));ot.range;const it=qn((n=>{n.setUTCHours(0,0,0,0)}),((n,t)=>{n.setUTCDate(n.getUTCDate()+t)}),((n,t)=>(t-n)/Xn),(n=>n.getUTCDate()-1));it.range;const at=qn((n=>{n.setUTCHours(0,0,0,0)}),((n,t)=>{n.setUTCDate(n.getUTCDate()+t)}),((n,t)=>(t-n)/Xn),(n=>Math.floor(n/Xn)));function ut(n){return qn((t=>{t.setDate(t.getDate()-(t.getDay()+7-n)%7),t.setHours(0,0,0,0)}),((n,t)=>{n.setDate(n.getDate()+7*t)}),((n,t)=>(t-n-(t.getTimezoneOffset()-n.getTimezoneOffset())*Vn)/Jn))}at.range;const lt=ut(0),ct=ut(1),st=ut(2),ft=ut(3),ht=ut(4),gt=ut(5),dt=ut(6);function pt(n){return qn((t=>{t.setUTCDate(t.getUTCDate()-(t.getUTCDay()+7-n)%7),t.setUTCHours(0,0,0,0)}),((n,t)=>{n.setUTCDate(n.getUTCDate()+7*t)}),((n,t)=>(t-n)/Jn))}lt.range,ct.range,st.range,ft.range,ht.range,gt.range,dt.range;const vt=pt(0),mt=pt(1),bt=pt(2),yt=pt(3),$t=pt(4),xt=pt(5),wt=pt(6);vt.range,mt.range,bt.range,yt.range,$t.range,xt.range,wt.range;const At=qn((n=>{n.setDate(1),n.setHours(0,0,0,0)}),((n,t)=>{n.setMonth(n.getMonth()+t)}),((n,t)=>t.getMonth()-n.getMonth()+12*(t.getFullYear()-n.getFullYear())),(n=>n.getMonth()));At.range;const Ct=qn((n=>{n.setUTCDate(1),n.setUTCHours(0,0,0,0)}),((n,t)=>{n.setUTCMonth(n.getUTCMonth()+t)}),((n,t)=>t.getUTCMonth()-n.getUTCMonth()+12*(t.getUTCFullYear()-n.getUTCFullYear())),(n=>n.getUTCMonth()));Ct.range;const _t=qn((n=>{n.setMonth(0,1),n.setHours(0,0,0,0)}),((n,t)=>{n.setFullYear(n.getFullYear()+t)}),((n,t)=>t.getFullYear()-n.getFullYear()),(n=>n.getFullYear()));_t.every=n=>isFinite(n=Math.floor(n))&&n>0?qn((t=>{t.setFullYear(Math.floor(t.getFullYear()/n)*n),t.setMonth(0,1),t.setHours(0,0,0,0)}),((t,e)=>{t.setFullYear(t.getFullYear()+e*n)})):null,_t.range;const kt=qn((n=>{n.setUTCMonth(0,1),n.setUTCHours(0,0,0,0)}),((n,t)=>{n.setUTCFullYear(n.getUTCFullYear()+t)}),((n,t)=>t.getUTCFullYear()-n.getUTCFullYear()),(n=>n.getUTCFullYear()));kt.every=n=>isFinite(n=Math.floor(n))&&n>0?qn((t=>{t.setUTCFullYear(Math.floor(t.getUTCFullYear()/n)*n),t.setUTCMonth(0,1),t.setUTCHours(0,0,0,0)}),((t,e)=>{t.setUTCFullYear(t.getUTCFullYear()+e*n)})):null,kt.range;const[Mt,Dt]=function(n,t,e,r,o,i){const a=[[Kn,1,Wn],[Kn,5,5e3],[Kn,15,15e3],[Kn,30,3e4],[i,1,Vn],[i,5,3e5],[i,15,9e5],[i,30,18e5],[o,1,Zn],[o,3,108e5],[o,6,216e5],[o,12,432e5],[r,1,Xn],[r,2,1728e5],[e,1,Jn],[t,1,2592e6],[t,3,7776e6],[n,1,Qn]];function u(t,e,r){const o=Math.abs(e-t)/r,i=p((([,,n])=>n)).right(a,o);if(i===a.length)return n.every(A(t/Qn,e/Qn,r));if(0===i)return Gn.every(Math.max(A(t,e,r),1));const[u,l]=a[o/a[i-1][2]<a[i][2]/o?i-1:i];return u.every(l)}return[function(n,t,e){const r=t<n;r&&([n,t]=[t,n]);const o=e&&"function"==typeof e.range?e:u(n,t,e),i=o?o.range(n,+t+1):[];return r?i.reverse():i},u]}(_t,At,lt,ot,et,nt);function Tt(n){if(0<=n.y&&n.y<100){var t=new Date(-1,n.m,n.d,n.H,n.M,n.S,n.L);return t.setFullYear(n.y),t}return new Date(n.y,n.m,n.d,n.H,n.M,n.S,n.L)}function Bt(n){if(0<=n.y&&n.y<100){var t=new Date(Date.UTC(-1,n.m,n.d,n.H,n.M,n.S,n.L));return t.setUTCFullYear(n.y),t}return new Date(Date.UTC(n.y,n.m,n.d,n.H,n.M,n.S,n.L))}function St(n,t,e){return{y:n,m:t,d:e,H:0,M:0,S:0,L:0}}var Ut,Nt,Ft={"-":"",_:" ",0:"0"},zt=/^\s*\d+/,Lt=/^%/,Et=/[\\^$*+?|[\]().{}]/g;function Ht(n,t,e){var r=n<0?"-":"",o=(r?-n:n)+"",i=o.length;return r+(i<e?new Array(e-i+1).join(t)+o:o)}function Yt(n){return n.replace(Et,"\\$&")}function Ot(n){return new RegExp("^(?:"+n.map(Yt).join("|")+")","i")}function It(n){return new Map(n.map(((n,t)=>[n.toLowerCase(),t])))}function jt(n,t,e){var r=zt.exec(t.slice(e,e+1));return r?(n.w=+r[0],e+r[0].length):-1}function Pt(n,t,e){var r=zt.exec(t.slice(e,e+1));return r?(n.u=+r[0],e+r[0].length):-1}function Rt(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.U=+r[0],e+r[0].length):-1}function qt(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.V=+r[0],e+r[0].length):-1}function Gt(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.W=+r[0],e+r[0].length):-1}function Wt(n,t,e){var r=zt.exec(t.slice(e,e+4));return r?(n.y=+r[0],e+r[0].length):-1}function Vt(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.y=+r[0]+(+r[0]>68?1900:2e3),e+r[0].length):-1}function Zt(n,t,e){var r=/^(Z)|([+-]\d\d)(?::?(\d\d))?/.exec(t.slice(e,e+6));return r?(n.Z=r[1]?0:-(r[2]+(r[3]||"00")),e+r[0].length):-1}function Xt(n,t,e){var r=zt.exec(t.slice(e,e+1));return r?(n.q=3*r[0]-3,e+r[0].length):-1}function Jt(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.m=r[0]-1,e+r[0].length):-1}function Qt(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.d=+r[0],e+r[0].length):-1}function Kt(n,t,e){var r=zt.exec(t.slice(e,e+3));return r?(n.m=0,n.d=+r[0],e+r[0].length):-1}function ne(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.H=+r[0],e+r[0].length):-1}function te(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.M=+r[0],e+r[0].length):-1}function ee(n,t,e){var r=zt.exec(t.slice(e,e+2));return r?(n.S=+r[0],e+r[0].length):-1}function re(n,t,e){var r=zt.exec(t.slice(e,e+3));return r?(n.L=+r[0],e+r[0].length):-1}function oe(n,t,e){var r=zt.exec(t.slice(e,e+6));return r?(n.L=Math.floor(r[0]/1e3),e+r[0].length):-1}function ie(n,t,e){var r=Lt.exec(t.slice(e,e+1));return r?e+r[0].length:-1}function ae(n,t,e){var r=zt.exec(t.slice(e));return r?(n.Q=+r[0],e+r[0].length):-1}function ue(n,t,e){var r=zt.exec(t.slice(e));return r?(n.s=+r[0],e+r[0].length):-1}function le(n,t){return Ht(n.getDate(),t,2)}function ce(n,t){return Ht(n.getHours(),t,2)}function se(n,t){return Ht(n.getHours()%12||12,t,2)}function fe(n,t){return Ht(1+ot.count(_t(n),n),t,3)}function he(n,t){return Ht(n.getMilliseconds(),t,3)}function ge(n,t){return he(n,t)+"000"}function de(n,t){return Ht(n.getMonth()+1,t,2)}function pe(n,t){return Ht(n.getMinutes(),t,2)}function ve(n,t){return Ht(n.getSeconds(),t,2)}function me(n){var t=n.getDay();return 0===t?7:t}function be(n,t){return Ht(lt.count(_t(n)-1,n),t,2)}function ye(n){var t=n.getDay();return t>=4||0===t?ht(n):ht.ceil(n)}function $e(n,t){return n=ye(n),Ht(ht.count(_t(n),n)+(4===_t(n).getDay()),t,2)}function xe(n){return n.getDay()}function we(n,t){return Ht(ct.count(_t(n)-1,n),t,2)}function Ae(n,t){return Ht(n.getFullYear()%100,t,2)}function Ce(n,t){return Ht((n=ye(n)).getFullYear()%100,t,2)}function _e(n,t){return Ht(n.getFullYear()%1e4,t,4)}function ke(n,t){var e=n.getDay();return Ht((n=e>=4||0===e?ht(n):ht.ceil(n)).getFullYear()%1e4,t,4)}function Me(n){var t=n.getTimezoneOffset();return(t>0?"-":(t*=-1,"+"))+Ht(t/60|0,"0",2)+Ht(t%60,"0",2)}function De(n,t){return Ht(n.getUTCDate(),t,2)}function Te(n,t){return Ht(n.getUTCHours(),t,2)}function Be(n,t){return Ht(n.getUTCHours()%12||12,t,2)}function Se(n,t){return Ht(1+it.count(kt(n),n),t,3)}function Ue(n,t){return Ht(n.getUTCMilliseconds(),t,3)}function Ne(n,t){return Ue(n,t)+"000"}function Fe(n,t){return Ht(n.getUTCMonth()+1,t,2)}function ze(n,t){return Ht(n.getUTCMinutes(),t,2)}function Le(n,t){return Ht(n.getUTCSeconds(),t,2)}function Ee(n){var t=n.getUTCDay();return 0===t?7:t}function He(n,t){return Ht(vt.count(kt(n)-1,n),t,2)}function Ye(n){var t=n.getUTCDay();return t>=4||0===t?$t(n):$t.ceil(n)}function Oe(n,t){return n=Ye(n),Ht($t.count(kt(n),n)+(4===kt(n).getUTCDay()),t,2)}function Ie(n){return n.getUTCDay()}function je(n,t){return Ht(mt.count(kt(n)-1,n),t,2)}function Pe(n,t){return Ht(n.getUTCFullYear()%100,t,2)}function Re(n,t){return Ht((n=Ye(n)).getUTCFullYear()%100,t,2)}function qe(n,t){return Ht(n.getUTCFullYear()%1e4,t,4)}function Ge(n,t){var e=n.getUTCDay();return Ht((n=e>=4||0===e?$t(n):$t.ceil(n)).getUTCFullYear()%1e4,t,4)}function We(){return"+0000"}function Ve(){return"%"}function Ze(n){return+n}function Xe(n){return Math.floor(+n/1e3)}function Je(n){return new Date(n)}function Qe(n){return n instanceof Date?+n:+new Date(+n)}function Ke(n,t,e,r,o,i,a,u,l,c){var s=kn(),f=s.invert,h=s.domain,g=c(".%L"),d=c(":%S"),p=c("%I:%M"),v=c("%I %p"),m=c("%a %d"),b=c("%b %d"),y=c("%B"),$=c("%Y");function x(n){return(l(n)<n?g:u(n)<n?d:a(n)<n?p:i(n)<n?v:r(n)<n?o(n)<n?m:b:e(n)<n?y:$)(n)}return s.invert=function(n){return new Date(f(n))},s.domain=function(n){return arguments.length?h(Array.from(n,Qe)):h().map(Je)},s.ticks=function(t){var e=h();return n(e[0],e[e.length-1],null==t?10:t)},s.tickFormat=function(n,t){return null==t?x:c(t)},s.nice=function(n){var e=h();return n&&"function"==typeof n.range||(n=t(e[0],e[e.length-1],null==n?10:n)),n?h(function(n,t){var e,r=0,o=(n=n.slice()).length-1,i=n[r],a=n[o];return a<i&&(e=r,r=o,o=e,e=i,i=a,a=e),n[r]=t.floor(i),n[o]=t.ceil(a),n}(e,n)):s},s.copy=function(){return _n(s,Ke(n,t,e,r,o,i,a,u,l,c))},s}function nr(){return C.apply(Ke(Mt,Dt,_t,At,lt,ot,et,nt,Kn,Nt).domain([new Date(2e3,0,1),new Date(2e3,0,2)]),arguments)}Ut=function(n){var t=n.dateTime,e=n.date,r=n.time,o=n.periods,i=n.days,a=n.shortDays,u=n.months,l=n.shortMonths,c=Ot(o),s=It(o),f=Ot(i),h=It(i),g=Ot(a),d=It(a),p=Ot(u),v=It(u),m=Ot(l),b=It(l),y={a:function(n){return a[n.getDay()]},A:function(n){return i[n.getDay()]},b:function(n){return l[n.getMonth()]},B:function(n){return u[n.getMonth()]},c:null,d:le,e:le,f:ge,g:Ce,G:ke,H:ce,I:se,j:fe,L:he,m:de,M:pe,p:function(n){return o[+(n.getHours()>=12)]},q:function(n){return 1+~~(n.getMonth()/3)},Q:Ze,s:Xe,S:ve,u:me,U:be,V:$e,w:xe,W:we,x:null,X:null,y:Ae,Y:_e,Z:Me,"%":Ve},$={a:function(n){return a[n.getUTCDay()]},A:function(n){return i[n.getUTCDay()]},b:function(n){return l[n.getUTCMonth()]},B:function(n){return u[n.getUTCMonth()]},c:null,d:De,e:De,f:Ne,g:Re,G:Ge,H:Te,I:Be,j:Se,L:Ue,m:Fe,M:ze,p:function(n){return o[+(n.getUTCHours()>=12)]},q:function(n){return 1+~~(n.getUTCMonth()/3)},Q:Ze,s:Xe,S:Le,u:Ee,U:He,V:Oe,w:Ie,W:je,x:null,X:null,y:Pe,Y:qe,Z:We,"%":Ve},x={a:function(n,t,e){var r=g.exec(t.slice(e));return r?(n.w=d.get(r[0].toLowerCase()),e+r[0].length):-1},A:function(n,t,e){var r=f.exec(t.slice(e));return r?(n.w=h.get(r[0].toLowerCase()),e+r[0].length):-1},b:function(n,t,e){var r=m.exec(t.slice(e));return r?(n.m=b.get(r[0].toLowerCase()),e+r[0].length):-1},B:function(n,t,e){var r=p.exec(t.slice(e));return r?(n.m=v.get(r[0].toLowerCase()),e+r[0].length):-1},c:function(n,e,r){return C(n,t,e,r)},d:Qt,e:Qt,f:oe,g:Vt,G:Wt,H:ne,I:ne,j:Kt,L:re,m:Jt,M:te,p:function(n,t,e){var r=c.exec(t.slice(e));return r?(n.p=s.get(r[0].toLowerCase()),e+r[0].length):-1},q:Xt,Q:ae,s:ue,S:ee,u:Pt,U:Rt,V:qt,w:jt,W:Gt,x:function(n,t,r){return C(n,e,t,r)},X:function(n,t,e){return C(n,r,t,e)},y:Vt,Y:Wt,Z:Zt,"%":ie};function w(n,t){return function(e){var r,o,i,a=[],u=-1,l=0,c=n.length;for(e instanceof Date||(e=new Date(+e));++u<c;)37===n.charCodeAt(u)&&(a.push(n.slice(l,u)),null!=(o=Ft[r=n.charAt(++u)])?r=n.charAt(++u):o="e"===r?" ":"0",(i=t[r])&&(r=i(e,o)),a.push(r),l=u+1);return a.push(n.slice(l,u)),a.join("")}}function A(n,t){return function(e){var r,o,i=St(1900,void 0,1);if(C(i,n,e+="",0)!=e.length)return null;if("Q"in i)return new Date(i.Q);if("s"in i)return new Date(1e3*i.s+("L"in i?i.L:0));if(t&&!("Z"in i)&&(i.Z=0),"p"in i&&(i.H=i.H%12+12*i.p),void 0===i.m&&(i.m="q"in i?i.q:0),"V"in i){if(i.V<1||i.V>53)return null;"w"in i||(i.w=1),"Z"in i?(o=(r=Bt(St(i.y,0,1))).getUTCDay(),r=o>4||0===o?mt.ceil(r):mt(r),r=it.offset(r,7*(i.V-1)),i.y=r.getUTCFullYear(),i.m=r.getUTCMonth(),i.d=r.getUTCDate()+(i.w+6)%7):(o=(r=Tt(St(i.y,0,1))).getDay(),r=o>4||0===o?ct.ceil(r):ct(r),r=ot.offset(r,7*(i.V-1)),i.y=r.getFullYear(),i.m=r.getMonth(),i.d=r.getDate()+(i.w+6)%7)}else("W"in i||"U"in i)&&("w"in i||(i.w="u"in i?i.u%7:"W"in i?1:0),o="Z"in i?Bt(St(i.y,0,1)).getUTCDay():Tt(St(i.y,0,1)).getDay(),i.m=0,i.d="W"in i?(i.w+6)%7+7*i.W-(o+5)%7:i.w+7*i.U-(o+6)%7);return"Z"in i?(i.H+=i.Z/100|0,i.M+=i.Z%100,Bt(i)):Tt(i)}}function C(n,t,e,r){for(var o,i,a=0,u=t.length,l=e.length;a<u;){if(r>=l)return-1;if(37===(o=t.charCodeAt(a++))){if(o=t.charAt(a++),!(i=x[o in Ft?t.charAt(a++):o])||(r=i(n,e,r))<0)return-1}else if(o!=e.charCodeAt(r++))return-1}return r}return y.x=w(e,y),y.X=w(r,y),y.c=w(t,y),$.x=w(e,$),$.X=w(r,$),$.c=w(t,$),{format:function(n){var t=w(n+="",y);return t.toString=function(){return n},t},parse:function(n){var t=A(n+="",!1);return t.toString=function(){return n},t},utcFormat:function(n){var t=w(n+="",$);return t.toString=function(){return n},t},utcParse:function(n){var t=A(n+="",!0);return t.toString=function(){return n},t}}}({dateTime:"%x, %X",date:"%-m/%-d/%Y",time:"%-I:%M:%S %p",periods:["AM","PM"],days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],shortDays:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],shortMonths:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]}),Nt=Ut.format,Ut.parse,Ut.utcFormat,Ut.utcParse;var tr="http://www.w3.org/1999/xhtml",er={svg:"http://www.w3.org/2000/svg",xhtml:tr,xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace",xmlns:"http://www.w3.org/2000/xmlns/"};function rr(n){var t=n+="",e=t.indexOf(":");return e>=0&&"xmlns"!==(t=n.slice(0,e))&&(n=n.slice(e+1)),er.hasOwnProperty(t)?{space:er[t],local:n}:n}function or(n){return function(){var t=this.ownerDocument,e=this.namespaceURI;return e===tr&&t.documentElement.namespaceURI===tr?t.createElement(n):t.createElementNS(e,n)}}function ir(n){return function(){return this.ownerDocument.createElementNS(n.space,n.local)}}function ar(n){var t=rr(n);return(t.local?ir:or)(t)}function ur(){}function lr(n){return null==n?ur:function(){return this.querySelector(n)}}function cr(n){return"object"==typeof n&&"length"in n?n:Array.from(n)}function sr(){return[]}function fr(n){return function(t){return t.matches(n)}}var hr=Array.prototype.find;function gr(){return this.firstElementChild}var dr=Array.prototype.filter;function pr(){return this.children}function vr(n){return new Array(n.length)}function mr(n,t){this.ownerDocument=n.ownerDocument,this.namespaceURI=n.namespaceURI,this._next=null,this._parent=n,this.__data__=t}function br(n,t,e,r,o,i){for(var a,u=0,l=t.length,c=i.length;u<c;++u)(a=t[u])?(a.__data__=i[u],r[u]=a):e[u]=new mr(n,i[u]);for(;u<l;++u)(a=t[u])&&(o[u]=a)}function yr(n,t,e,r,o,i,a){var u,l,c,s=new Map,f=t.length,h=i.length,g=new Array(f);for(u=0;u<f;++u)(l=t[u])&&(g[u]=c=a.call(l,l.__data__,u,t)+"",s.has(c)?o[u]=l:s.set(c,l));for(u=0;u<h;++u)c=a.call(n,i[u],u,i)+"",(l=s.get(c))?(r[u]=l,l.__data__=i[u],s.delete(c)):e[u]=new mr(n,i[u]);for(u=0;u<f;++u)(l=t[u])&&s.get(g[u])===l&&(o[u]=l)}function $r(n){return n.__data__}function xr(n,t){return n<t?-1:n>t?1:n>=t?0:NaN}function wr(n){return function(){this.removeAttribute(n)}}function Ar(n){return function(){this.removeAttributeNS(n.space,n.local)}}function Cr(n,t){return function(){this.setAttribute(n,t)}}function _r(n,t){return function(){this.setAttributeNS(n.space,n.local,t)}}function kr(n,t){return function(){var e=t.apply(this,arguments);null==e?this.removeAttribute(n):this.setAttribute(n,e)}}function Mr(n,t){return function(){var e=t.apply(this,arguments);null==e?this.removeAttributeNS(n.space,n.local):this.setAttributeNS(n.space,n.local,e)}}function Dr(n){return n.ownerDocument&&n.ownerDocument.defaultView||n.document&&n||n.defaultView}function Tr(n){return function(){this.style.removeProperty(n)}}function Br(n,t,e){return function(){this.style.setProperty(n,t,e)}}function Sr(n,t,e){return function(){var r=t.apply(this,arguments);null==r?this.style.removeProperty(n):this.style.setProperty(n,r,e)}}function Ur(n){return function(){delete this[n]}}function Nr(n,t){return function(){this[n]=t}}function Fr(n,t){return function(){var e=t.apply(this,arguments);null==e?delete this[n]:this[n]=e}}function zr(n){return n.trim().split(/^|\s+/)}function Lr(n){return n.classList||new Er(n)}function Er(n){this._node=n,this._names=zr(n.getAttribute("class")||"")}function Hr(n,t){for(var e=Lr(n),r=-1,o=t.length;++r<o;)e.add(t[r])}function Yr(n,t){for(var e=Lr(n),r=-1,o=t.length;++r<o;)e.remove(t[r])}function Or(n){return function(){Hr(this,n)}}function Ir(n){return function(){Yr(this,n)}}function jr(n,t){return function(){(t.apply(this,arguments)?Hr:Yr)(this,n)}}function Pr(){this.textContent=""}function Rr(n){return function(){this.textContent=n}}function qr(n){return function(){var t=n.apply(this,arguments);this.textContent=null==t?"":t}}function Gr(){this.innerHTML=""}function Wr(n){return function(){this.innerHTML=n}}function Vr(n){return function(){var t=n.apply(this,arguments);this.innerHTML=null==t?"":t}}function Zr(){this.nextSibling&&this.parentNode.appendChild(this)}function Xr(){this.previousSibling&&this.parentNode.insertBefore(this,this.parentNode.firstChild)}function Jr(){return null}function Qr(){var n=this.parentNode;n&&n.removeChild(this)}function Kr(){var n=this.cloneNode(!1),t=this.parentNode;return t?t.insertBefore(n,this.nextSibling):n}function no(){var n=this.cloneNode(!0),t=this.parentNode;return t?t.insertBefore(n,this.nextSibling):n}function to(n){return function(){var t=this.__on;if(t){for(var e,r=0,o=-1,i=t.length;r<i;++r)e=t[r],n.type&&e.type!==n.type||e.name!==n.name?t[++o]=e:this.removeEventListener(e.type,e.listener,e.options);++o?t.length=o:delete this.__on}}}function eo(n,t,e){return function(){var r,o=this.__on,i=function(n){return function(t){n.call(this,t,this.__data__)}}(t);if(o)for(var a=0,u=o.length;a<u;++a)if((r=o[a]).type===n.type&&r.name===n.name)return this.removeEventListener(r.type,r.listener,r.options),this.addEventListener(r.type,r.listener=i,r.options=e),void(r.value=t);this.addEventListener(n.type,i,e),r={type:n.type,name:n.name,value:t,listener:i,options:e},o?o.push(r):this.__on=[r]}}function ro(n,t,e){var r=Dr(n),o=r.CustomEvent;"function"==typeof o?o=new o(t,e):(o=r.document.createEvent("Event"),e?(o.initEvent(t,e.bubbles,e.cancelable),o.detail=e.detail):o.initEvent(t,!1,!1)),n.dispatchEvent(o)}function oo(n,t){return function(){return ro(this,n,t)}}function io(n,t){return function(){return ro(this,n,t.apply(this,arguments))}}mr.prototype={constructor:mr,appendChild:function(n){return this._parent.insertBefore(n,this._next)},insertBefore:function(n,t){return this._parent.insertBefore(n,t)},querySelector:function(n){return this._parent.querySelector(n)},querySelectorAll:function(n){return this._parent.querySelectorAll(n)}},Er.prototype={add:function(n){this._names.indexOf(n)<0&&(this._names.push(n),this._node.setAttribute("class",this._names.join(" ")))},remove:function(n){var t=this._names.indexOf(n);t>=0&&(this._names.splice(t,1),this._node.setAttribute("class",this._names.join(" ")))},contains:function(n){return this._names.indexOf(n)>=0}};var ao=[null];function uo(n,t){this._groups=n,this._parents=t}function lo(n){return"string"==typeof n?new uo([[document.querySelector(n)]],[document.documentElement]):new uo([[n]],ao)}uo.prototype={constructor:uo,select:function(n){"function"!=typeof n&&(n=lr(n));for(var t=this._groups,e=t.length,r=new Array(e),o=0;o<e;++o)for(var i,a,u=t[o],l=u.length,c=r[o]=new Array(l),s=0;s<l;++s)(i=u[s])&&(a=n.call(i,i.__data__,s,u))&&("__data__"in i&&(a.__data__=i.__data__),c[s]=a);return new uo(r,this._parents)},selectAll:function(n){n="function"==typeof n?function(n){return function(){var t=n.apply(this,arguments);return null==t?[]:cr(t)}}(n):function(n){return null==n?sr:function(){return this.querySelectorAll(n)}}(n);for(var t=this._groups,e=t.length,r=[],o=[],i=0;i<e;++i)for(var a,u=t[i],l=u.length,c=0;c<l;++c)(a=u[c])&&(r.push(n.call(a,a.__data__,c,u)),o.push(a));return new uo(r,o)},selectChild:function(n){return this.select(null==n?gr:function(n){return function(){return hr.call(this.children,n)}}("function"==typeof n?n:fr(n)))},selectChildren:function(n){return this.selectAll(null==n?pr:function(n){return function(){return dr.call(this.children,n)}}("function"==typeof n?n:fr(n)))},filter:function(n){"function"!=typeof n&&(n=function(n){return function(){return this.matches(n)}}(n));for(var t=this._groups,e=t.length,r=new Array(e),o=0;o<e;++o)for(var i,a=t[o],u=a.length,l=r[o]=[],c=0;c<u;++c)(i=a[c])&&n.call(i,i.__data__,c,a)&&l.push(i);return new uo(r,this._parents)},data:function(n,t){if(!arguments.length)return Array.from(this,$r);var e,r=t?yr:br,o=this._parents,i=this._groups;"function"!=typeof n&&(e=n,n=function(){return e});for(var a=i.length,u=new Array(a),l=new Array(a),c=new Array(a),s=0;s<a;++s){var f=o[s],h=i[s],g=h.length,d=cr(n.call(f,f&&f.__data__,s,o)),p=d.length,v=l[s]=new Array(p),m=u[s]=new Array(p);r(f,h,v,m,c[s]=new Array(g),d,t);for(var b,y,$=0,x=0;$<p;++$)if(b=v[$]){for($>=x&&(x=$+1);!(y=m[x])&&++x<p;);b._next=y||null}}return(u=new uo(u,o))._enter=l,u._exit=c,u},enter:function(){return new uo(this._enter||this._groups.map(vr),this._parents)},exit:function(){return new uo(this._exit||this._groups.map(vr),this._parents)},join:function(n,t,e){var r=this.enter(),o=this,i=this.exit();return r="function"==typeof n?n(r):r.append(n+""),null!=t&&(o=t(o)),null==e?i.remove():e(i),r&&o?r.merge(o).order():o},merge:function(n){if(!(n instanceof uo))throw new Error("invalid merge");for(var t=this._groups,e=n._groups,r=t.length,o=e.length,i=Math.min(r,o),a=new Array(r),u=0;u<i;++u)for(var l,c=t[u],s=e[u],f=c.length,h=a[u]=new Array(f),g=0;g<f;++g)(l=c[g]||s[g])&&(h[g]=l);for(;u<r;++u)a[u]=t[u];return new uo(a,this._parents)},selection:function(){return this},order:function(){for(var n=this._groups,t=-1,e=n.length;++t<e;)for(var r,o=n[t],i=o.length-1,a=o[i];--i>=0;)(r=o[i])&&(a&&4^r.compareDocumentPosition(a)&&a.parentNode.insertBefore(r,a),a=r);return this},sort:function(n){function t(t,e){return t&&e?n(t.__data__,e.__data__):!t-!e}n||(n=xr);for(var e=this._groups,r=e.length,o=new Array(r),i=0;i<r;++i){for(var a,u=e[i],l=u.length,c=o[i]=new Array(l),s=0;s<l;++s)(a=u[s])&&(c[s]=a);c.sort(t)}return new uo(o,this._parents).order()},call:function(){var n=arguments[0];return arguments[0]=this,n.apply(null,arguments),this},nodes:function(){return Array.from(this)},node:function(){for(var n=this._groups,t=0,e=n.length;t<e;++t)for(var r=n[t],o=0,i=r.length;o<i;++o){var a=r[o];if(a)return a}return null},size:function(){let n=0;for(const t of this)++n;return n},empty:function(){return!this.node()},each:function(n){for(var t=this._groups,e=0,r=t.length;e<r;++e)for(var o,i=t[e],a=0,u=i.length;a<u;++a)(o=i[a])&&n.call(o,o.__data__,a,i);return this},attr:function(n,t){var e=rr(n);if(arguments.length<2){var r=this.node();return e.local?r.getAttributeNS(e.space,e.local):r.getAttribute(e)}return this.each((null==t?e.local?Ar:wr:"function"==typeof t?e.local?Mr:kr:e.local?_r:Cr)(e,t))},style:function(n,t,e){return arguments.length>1?this.each((null==t?Tr:"function"==typeof t?Sr:Br)(n,t,null==e?"":e)):function(n,t){return n.style.getPropertyValue(t)||Dr(n).getComputedStyle(n,null).getPropertyValue(t)}(this.node(),n)},property:function(n,t){return arguments.length>1?this.each((null==t?Ur:"function"==typeof t?Fr:Nr)(n,t)):this.node()[n]},classed:function(n,t){var e=zr(n+"");if(arguments.length<2){for(var r=Lr(this.node()),o=-1,i=e.length;++o<i;)if(!r.contains(e[o]))return!1;return!0}return this.each(("function"==typeof t?jr:t?Or:Ir)(e,t))},text:function(n){return arguments.length?this.each(null==n?Pr:("function"==typeof n?qr:Rr)(n)):this.node().textContent},html:function(n){return arguments.length?this.each(null==n?Gr:("function"==typeof n?Vr:Wr)(n)):this.node().innerHTML},raise:function(){return this.each(Zr)},lower:function(){return this.each(Xr)},append:function(n){var t="function"==typeof n?n:ar(n);return this.select((function(){return this.appendChild(t.apply(this,arguments))}))},insert:function(n,t){var e="function"==typeof n?n:ar(n),r=null==t?Jr:"function"==typeof t?t:lr(t);return this.select((function(){return this.insertBefore(e.apply(this,arguments),r.apply(this,arguments)||null)}))},remove:function(){return this.each(Qr)},clone:function(n){return this.select(n?no:Kr)},datum:function(n){return arguments.length?this.property("__data__",n):this.node().__data__},on:function(n,t,e){var r,o,i=function(n){return n.trim().split(/^|\s+/).map((function(n){var t="",e=n.indexOf(".");return e>=0&&(t=n.slice(e+1),n=n.slice(0,e)),{type:n,name:t}}))}(n+""),a=i.length;if(!(arguments.length<2)){for(u=t?eo:to,r=0;r<a;++r)this.each(u(i[r],t,e));return this}var u=this.node().__on;if(u)for(var l,c=0,s=u.length;c<s;++c)for(r=0,l=u[c];r<a;++r)if((o=i[r]).type===l.type&&o.name===l.name)return l.value},dispatch:function(n,t){return this.each(("function"==typeof t?io:oo)(n,t))},[Symbol.iterator]:function*(){for(var n=this._groups,t=0,e=n.length;t<e;++t)for(var r,o=n[t],i=0,a=o.length;i<a;++i)(r=o[i])&&(yield r)}};var co=function(n){var t=n._step,e=n._serverDelay,r=n._clientDelay,o=n._scale,i=n._size,a=Date.now();return n._stop0=new Date(Math.floor((a-e-r)/t)*t),n._start0=new Date(n._stop0-i*t),n._stop1=new Date(Math.floor((a-e)/t)*t),n._start1=new Date(n._stop1-i*t),o.domain([n._start0,n._stop0]),n},so=function n(t,e){return function(r,o){return Object.assign({},r,{valueAt:function(n){return e(r.valueAt(n),o.valueAt(n))},toString:function(){return"".concat(r," ").concat(t," ").concat(o)},on:function(n){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(null===t)return r.on(n);r.on(n,t),o.on(n,t)}},{shift:function(i){return n(t,e)(r.shift(i),o.shift(i))}})}},fo=function(n){return{metric:function(t,e){var r,o={context:n,_id:".metric-"+ ++n._id,_start:-1/0,_stop:null,_step:n.step(),_size:n.size(),_values:[],_event:u("change"),_listening:0,_fetching:!1},i=Object.assign(o,function(n,t){return{on:function(e){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,o=n._event,i=n._id,a=n.context,u=n._start,l=n._stop;return null===r?o.on(e):(null==r?null!=o.on(e)&&0==--n._listening&&a.on("prepare"+i,null).on("beforechange"+i,null):null==o.on(e)&&1==++n._listening&&a.on("prepare"+i,function(n,t){return function(e,r){var o=n._start,i=n._step,a=n._fetching,u=n._event,l=n._size,c=Math.min(l,Math.round((e-o)/i));if(c&&!a){n._fetching=!0,n._steps=Math.min(l,c+6);var s=new Date(r-n._steps*i);t(s,r,i,(function(t,e){if(n._fetching=!1,t)return console.warn(t);for(var a=isFinite(o)?Math.round((s-o)/i):0,l=0,c=e.length;l<c;++l)n._values[l+a]=e[l];u.call("change",o,r)}))}}}(n,t)).on("beforechange"+i,function(n){return function(t,e){var r=n._step,o=n._size;isFinite(n._start)||(n._start=t),n._values.splice(0,Math.max(0,Math.min(o,Math.round((t-n._start)/r)))),n._start=t,n._stop=e}}(n)),o.on(e,r),null!=r&&/^change(\.|$)/.test(e)&&r(u,l),n)}}}(o,t),function(n,t){return{prepare:function(e,r){var o=n._size,i=n._start,a=n._step,u=n._fetching,l=n._event,c=Math.min(o,Math.round((e-i)/a));if(c&&!0!==u){n._fetching=!0,n._steps=Math.min(o,c+6);var s=new Date(r-c*a);t(s,r,a,(function(t,e){if(n._fetching=!1,t)return console.warn(t);for(var o=isFinite(i)?Math.round((s-i)/a):0,u=0,c=e.length;u<c;++u)values[u+o]=e[u];l.call("change",n,i,r)}))}}}}(o,t),(r=o,{valueAt:function(n){return r._values[n]}}),function(n){return{alias:function(t){return n.toString=function(){return t},n}}}(o),function(n,t){return{shift:function(e){return n.context.metric(function(n,t){return function(e,r,o,i){return n(new Date(+e+t),new Date(+r+t),o,i)}}(t,+e))}}}(o,t),function(n){return{extent:function(){for(var t,e=n._size,r=n._values,o=0,i=1/0,a=-1/0;++o<e;)(t=r[o])<i&&(i=t),t>a&&(a=t);return[i,a]}}}(o),function(n){return{toString:function(){return n}}}(e));return Object.assign(i,function(n){return{add:function(t){return so("+",(function(n,t){return n+t}))(n,t)},subtract:function(t){return so("-",(function(n,t){return n-t}))(n,t)},multiply:function(t){return so("*",(function(n,t){return n*t}))(n,t)},divide:function(t){return so("/",(function(n,t){return n/t}))(n,t)}}}(i))}}},ho=new Date,go=new Date;function po(n,t,e,r){function o(t){return n(t=0===arguments.length?new Date:new Date(+t)),t}return o.floor=function(t){return n(t=new Date(+t)),t},o.ceil=function(e){return n(e=new Date(e-1)),t(e,1),n(e),e},o.round=function(n){var t=o(n),e=o.ceil(n);return n-t<e-n?t:e},o.offset=function(n,e){return t(n=new Date(+n),null==e?1:Math.floor(e)),n},o.range=function(e,r,i){var a,u=[];if(e=o.ceil(e),i=null==i?1:Math.floor(i),!(e<r&&i>0))return u;do{u.push(a=new Date(+e)),t(e,i),n(e)}while(a<e&&e<r);return u},o.filter=function(e){return po((function(t){if(t>=t)for(;n(t),!e(t);)t.setTime(t-1)}),(function(n,r){if(n>=n)if(r<0)for(;++r<=0;)for(;t(n,-1),!e(n););else for(;--r>=0;)for(;t(n,1),!e(n););}))},e&&(o.count=function(t,r){return ho.setTime(+t),go.setTime(+r),n(ho),n(go),Math.floor(e(ho,go))},o.every=function(n){return n=Math.floor(n),isFinite(n)&&n>0?n>1?o.filter(r?function(t){return r(t)%n==0}:function(t){return o.count(0,t)%n==0}):o:null}),o}const vo=864e5,mo=6048e5;var bo=po((n=>n.setHours(0,0,0,0)),((n,t)=>n.setDate(n.getDate()+t)),((n,t)=>(t-n-6e4*(t.getTimezoneOffset()-n.getTimezoneOffset()))/vo),(n=>n.getDate()-1));function yo(n){return po((function(t){t.setDate(t.getDate()-(t.getDay()+7-n)%7),t.setHours(0,0,0,0)}),(function(n,t){n.setDate(n.getDate()+7*t)}),(function(n,t){return(t-n-6e4*(t.getTimezoneOffset()-n.getTimezoneOffset()))/mo}))}bo.range;var $o=yo(0),xo=yo(1),wo=yo(2),Ao=yo(3),Co=yo(4),_o=yo(5),ko=yo(6);$o.range,xo.range,wo.range,Ao.range,Co.range,_o.range,ko.range;var Mo=po((function(n){n.setMonth(0,1),n.setHours(0,0,0,0)}),(function(n,t){n.setFullYear(n.getFullYear()+t)}),(function(n,t){return t.getFullYear()-n.getFullYear()}),(function(n){return n.getFullYear()}));Mo.every=function(n){return isFinite(n=Math.floor(n))&&n>0?po((function(t){t.setFullYear(Math.floor(t.getFullYear()/n)*n),t.setMonth(0,1),t.setHours(0,0,0,0)}),(function(t,e){t.setFullYear(t.getFullYear()+e*n)})):null},Mo.range;var Do=po((function(n){n.setUTCHours(0,0,0,0)}),(function(n,t){n.setUTCDate(n.getUTCDate()+t)}),(function(n,t){return(t-n)/vo}),(function(n){return n.getUTCDate()-1}));function To(n){return po((function(t){t.setUTCDate(t.getUTCDate()-(t.getUTCDay()+7-n)%7),t.setUTCHours(0,0,0,0)}),(function(n,t){n.setUTCDate(n.getUTCDate()+7*t)}),(function(n,t){return(t-n)/mo}))}Do.range;var Bo=To(0),So=To(1),Uo=To(2),No=To(3),Fo=To(4),zo=To(5),Lo=To(6);Bo.range,So.range,Uo.range,No.range,Fo.range,zo.range,Lo.range;var Eo=po((function(n){n.setUTCMonth(0,1),n.setUTCHours(0,0,0,0)}),(function(n,t){n.setUTCFullYear(n.getUTCFullYear()+t)}),(function(n,t){return t.getUTCFullYear()-n.getUTCFullYear()}),(function(n){return n.getUTCFullYear()}));function Ho(n){if(0<=n.y&&n.y<100){var t=new Date(-1,n.m,n.d,n.H,n.M,n.S,n.L);return t.setFullYear(n.y),t}return new Date(n.y,n.m,n.d,n.H,n.M,n.S,n.L)}function Yo(n){if(0<=n.y&&n.y<100){var t=new Date(Date.UTC(-1,n.m,n.d,n.H,n.M,n.S,n.L));return t.setUTCFullYear(n.y),t}return new Date(Date.UTC(n.y,n.m,n.d,n.H,n.M,n.S,n.L))}function Oo(n,t,e){return{y:n,m:t,d:e,H:0,M:0,S:0,L:0}}Eo.every=function(n){return isFinite(n=Math.floor(n))&&n>0?po((function(t){t.setUTCFullYear(Math.floor(t.getUTCFullYear()/n)*n),t.setUTCMonth(0,1),t.setUTCHours(0,0,0,0)}),(function(t,e){t.setUTCFullYear(t.getUTCFullYear()+e*n)})):null},Eo.range;var Io,jo,Po,Ro={"-":"",_:" ",0:"0"},qo=/^\s*\d+/,Go=/^%/,Wo=/[\\^$*+?|[\]().{}]/g;function Vo(n,t,e){var r=n<0?"-":"",o=(r?-n:n)+"",i=o.length;return r+(i<e?new Array(e-i+1).join(t)+o:o)}function Zo(n){return n.replace(Wo,"\\$&")}function Xo(n){return new RegExp("^(?:"+n.map(Zo).join("|")+")","i")}function Jo(n){return new Map(n.map(((n,t)=>[n.toLowerCase(),t])))}function Qo(n,t,e){var r=qo.exec(t.slice(e,e+1));return r?(n.w=+r[0],e+r[0].length):-1}function Ko(n,t,e){var r=qo.exec(t.slice(e,e+1));return r?(n.u=+r[0],e+r[0].length):-1}function ni(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.U=+r[0],e+r[0].length):-1}function ti(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.V=+r[0],e+r[0].length):-1}function ei(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.W=+r[0],e+r[0].length):-1}function ri(n,t,e){var r=qo.exec(t.slice(e,e+4));return r?(n.y=+r[0],e+r[0].length):-1}function oi(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.y=+r[0]+(+r[0]>68?1900:2e3),e+r[0].length):-1}function ii(n,t,e){var r=/^(Z)|([+-]\d\d)(?::?(\d\d))?/.exec(t.slice(e,e+6));return r?(n.Z=r[1]?0:-(r[2]+(r[3]||"00")),e+r[0].length):-1}function ai(n,t,e){var r=qo.exec(t.slice(e,e+1));return r?(n.q=3*r[0]-3,e+r[0].length):-1}function ui(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.m=r[0]-1,e+r[0].length):-1}function li(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.d=+r[0],e+r[0].length):-1}function ci(n,t,e){var r=qo.exec(t.slice(e,e+3));return r?(n.m=0,n.d=+r[0],e+r[0].length):-1}function si(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.H=+r[0],e+r[0].length):-1}function fi(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.M=+r[0],e+r[0].length):-1}function hi(n,t,e){var r=qo.exec(t.slice(e,e+2));return r?(n.S=+r[0],e+r[0].length):-1}function gi(n,t,e){var r=qo.exec(t.slice(e,e+3));return r?(n.L=+r[0],e+r[0].length):-1}function di(n,t,e){var r=qo.exec(t.slice(e,e+6));return r?(n.L=Math.floor(r[0]/1e3),e+r[0].length):-1}function pi(n,t,e){var r=Go.exec(t.slice(e,e+1));return r?e+r[0].length:-1}function vi(n,t,e){var r=qo.exec(t.slice(e));return r?(n.Q=+r[0],e+r[0].length):-1}function mi(n,t,e){var r=qo.exec(t.slice(e));return r?(n.s=+r[0],e+r[0].length):-1}function bi(n,t){return Vo(n.getDate(),t,2)}function yi(n,t){return Vo(n.getHours(),t,2)}function $i(n,t){return Vo(n.getHours()%12||12,t,2)}function xi(n,t){return Vo(1+bo.count(Mo(n),n),t,3)}function wi(n,t){return Vo(n.getMilliseconds(),t,3)}function Ai(n,t){return wi(n,t)+"000"}function Ci(n,t){return Vo(n.getMonth()+1,t,2)}function _i(n,t){return Vo(n.getMinutes(),t,2)}function ki(n,t){return Vo(n.getSeconds(),t,2)}function Mi(n){var t=n.getDay();return 0===t?7:t}function Di(n,t){return Vo($o.count(Mo(n)-1,n),t,2)}function Ti(n){var t=n.getDay();return t>=4||0===t?Co(n):Co.ceil(n)}function Bi(n,t){return n=Ti(n),Vo(Co.count(Mo(n),n)+(4===Mo(n).getDay()),t,2)}function Si(n){return n.getDay()}function Ui(n,t){return Vo(xo.count(Mo(n)-1,n),t,2)}function Ni(n,t){return Vo(n.getFullYear()%100,t,2)}function Fi(n,t){return Vo((n=Ti(n)).getFullYear()%100,t,2)}function zi(n,t){return Vo(n.getFullYear()%1e4,t,4)}function Li(n,t){var e=n.getDay();return Vo((n=e>=4||0===e?Co(n):Co.ceil(n)).getFullYear()%1e4,t,4)}function Ei(n){var t=n.getTimezoneOffset();return(t>0?"-":(t*=-1,"+"))+Vo(t/60|0,"0",2)+Vo(t%60,"0",2)}function Hi(n,t){return Vo(n.getUTCDate(),t,2)}function Yi(n,t){return Vo(n.getUTCHours(),t,2)}function Oi(n,t){return Vo(n.getUTCHours()%12||12,t,2)}function Ii(n,t){return Vo(1+Do.count(Eo(n),n),t,3)}function ji(n,t){return Vo(n.getUTCMilliseconds(),t,3)}function Pi(n,t){return ji(n,t)+"000"}function Ri(n,t){return Vo(n.getUTCMonth()+1,t,2)}function qi(n,t){return Vo(n.getUTCMinutes(),t,2)}function Gi(n,t){return Vo(n.getUTCSeconds(),t,2)}function Wi(n){var t=n.getUTCDay();return 0===t?7:t}function Vi(n,t){return Vo(Bo.count(Eo(n)-1,n),t,2)}function Zi(n){var t=n.getUTCDay();return t>=4||0===t?Fo(n):Fo.ceil(n)}function Xi(n,t){return n=Zi(n),Vo(Fo.count(Eo(n),n)+(4===Eo(n).getUTCDay()),t,2)}function Ji(n){return n.getUTCDay()}function Qi(n,t){return Vo(So.count(Eo(n)-1,n),t,2)}function Ki(n,t){return Vo(n.getUTCFullYear()%100,t,2)}function na(n,t){return Vo((n=Zi(n)).getUTCFullYear()%100,t,2)}function ta(n,t){return Vo(n.getUTCFullYear()%1e4,t,4)}function ea(n,t){var e=n.getUTCDay();return Vo((n=e>=4||0===e?Fo(n):Fo.ceil(n)).getUTCFullYear()%1e4,t,4)}function ra(){return"+0000"}function oa(){return"%"}function ia(n){return+n}function aa(n){return Math.floor(+n/1e3)}Io=function(n){var t=n.dateTime,e=n.date,r=n.time,o=n.periods,i=n.days,a=n.shortDays,u=n.months,l=n.shortMonths,c=Xo(o),s=Jo(o),f=Xo(i),h=Jo(i),g=Xo(a),d=Jo(a),p=Xo(u),v=Jo(u),m=Xo(l),b=Jo(l),y={a:function(n){return a[n.getDay()]},A:function(n){return i[n.getDay()]},b:function(n){return l[n.getMonth()]},B:function(n){return u[n.getMonth()]},c:null,d:bi,e:bi,f:Ai,g:Fi,G:Li,H:yi,I:$i,j:xi,L:wi,m:Ci,M:_i,p:function(n){return o[+(n.getHours()>=12)]},q:function(n){return 1+~~(n.getMonth()/3)},Q:ia,s:aa,S:ki,u:Mi,U:Di,V:Bi,w:Si,W:Ui,x:null,X:null,y:Ni,Y:zi,Z:Ei,"%":oa},$={a:function(n){return a[n.getUTCDay()]},A:function(n){return i[n.getUTCDay()]},b:function(n){return l[n.getUTCMonth()]},B:function(n){return u[n.getUTCMonth()]},c:null,d:Hi,e:Hi,f:Pi,g:na,G:ea,H:Yi,I:Oi,j:Ii,L:ji,m:Ri,M:qi,p:function(n){return o[+(n.getUTCHours()>=12)]},q:function(n){return 1+~~(n.getUTCMonth()/3)},Q:ia,s:aa,S:Gi,u:Wi,U:Vi,V:Xi,w:Ji,W:Qi,x:null,X:null,y:Ki,Y:ta,Z:ra,"%":oa},x={a:function(n,t,e){var r=g.exec(t.slice(e));return r?(n.w=d.get(r[0].toLowerCase()),e+r[0].length):-1},A:function(n,t,e){var r=f.exec(t.slice(e));return r?(n.w=h.get(r[0].toLowerCase()),e+r[0].length):-1},b:function(n,t,e){var r=m.exec(t.slice(e));return r?(n.m=b.get(r[0].toLowerCase()),e+r[0].length):-1},B:function(n,t,e){var r=p.exec(t.slice(e));return r?(n.m=v.get(r[0].toLowerCase()),e+r[0].length):-1},c:function(n,e,r){return C(n,t,e,r)},d:li,e:li,f:di,g:oi,G:ri,H:si,I:si,j:ci,L:gi,m:ui,M:fi,p:function(n,t,e){var r=c.exec(t.slice(e));return r?(n.p=s.get(r[0].toLowerCase()),e+r[0].length):-1},q:ai,Q:vi,s:mi,S:hi,u:Ko,U:ni,V:ti,w:Qo,W:ei,x:function(n,t,r){return C(n,e,t,r)},X:function(n,t,e){return C(n,r,t,e)},y:oi,Y:ri,Z:ii,"%":pi};function w(n,t){return function(e){var r,o,i,a=[],u=-1,l=0,c=n.length;for(e instanceof Date||(e=new Date(+e));++u<c;)37===n.charCodeAt(u)&&(a.push(n.slice(l,u)),null!=(o=Ro[r=n.charAt(++u)])?r=n.charAt(++u):o="e"===r?" ":"0",(i=t[r])&&(r=i(e,o)),a.push(r),l=u+1);return a.push(n.slice(l,u)),a.join("")}}function A(n,t){return function(e){var r,o,i=Oo(1900,void 0,1);if(C(i,n,e+="",0)!=e.length)return null;if("Q"in i)return new Date(i.Q);if("s"in i)return new Date(1e3*i.s+("L"in i?i.L:0));if(t&&!("Z"in i)&&(i.Z=0),"p"in i&&(i.H=i.H%12+12*i.p),void 0===i.m&&(i.m="q"in i?i.q:0),"V"in i){if(i.V<1||i.V>53)return null;"w"in i||(i.w=1),"Z"in i?(o=(r=Yo(Oo(i.y,0,1))).getUTCDay(),r=o>4||0===o?So.ceil(r):So(r),r=Do.offset(r,7*(i.V-1)),i.y=r.getUTCFullYear(),i.m=r.getUTCMonth(),i.d=r.getUTCDate()+(i.w+6)%7):(o=(r=Ho(Oo(i.y,0,1))).getDay(),r=o>4||0===o?xo.ceil(r):xo(r),r=bo.offset(r,7*(i.V-1)),i.y=r.getFullYear(),i.m=r.getMonth(),i.d=r.getDate()+(i.w+6)%7)}else("W"in i||"U"in i)&&("w"in i||(i.w="u"in i?i.u%7:"W"in i?1:0),o="Z"in i?Yo(Oo(i.y,0,1)).getUTCDay():Ho(Oo(i.y,0,1)).getDay(),i.m=0,i.d="W"in i?(i.w+6)%7+7*i.W-(o+5)%7:i.w+7*i.U-(o+6)%7);return"Z"in i?(i.H+=i.Z/100|0,i.M+=i.Z%100,Yo(i)):Ho(i)}}function C(n,t,e,r){for(var o,i,a=0,u=t.length,l=e.length;a<u;){if(r>=l)return-1;if(37===(o=t.charCodeAt(a++))){if(o=t.charAt(a++),!(i=x[o in Ro?t.charAt(a++):o])||(r=i(n,e,r))<0)return-1}else if(o!=e.charCodeAt(r++))return-1}return r}return y.x=w(e,y),y.X=w(r,y),y.c=w(t,y),$.x=w(e,$),$.X=w(r,$),$.c=w(t,$),{format:function(n){var t=w(n+="",y);return t.toString=function(){return n},t},parse:function(n){var t=A(n+="",!1);return t.toString=function(){return n},t},utcFormat:function(n){var t=w(n+="",$);return t.toString=function(){return n},t},utcParse:function(n){var t=A(n+="",!0);return t.toString=function(){return n},t}}}({dateTime:"%x, %X",date:"%-m/%-d/%Y",time:"%-I:%M:%S %p",periods:["AM","PM"],days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],shortDays:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],shortMonths:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]}),jo=Io.format,Io.parse,Po=Io.utcFormat,Io.utcParse;var ua=Date.prototype.toISOString?function(n){return n.toISOString()}:Po("%Y-%m-%dT%H:%M:%S.%LZ");function la(n){if(!n.ok)throw new Error(n.status+" "+n.statusText);return n.text()}function ca(n){if(!n.ok)throw new Error(n.status+" "+n.statusText);if(204!==n.status&&205!==n.status)return n.json()}function sa(n,t){return fetch(n,t).then(ca)}var fa=Array.prototype.slice;function ha(n){return n}var ga=1,da=2,pa=3,va=4,ma=1e-6;function ba(n){return"translate("+n+",0)"}function ya(n){return"translate(0,"+n+")"}function $a(n){return t=>+n(t)}function xa(n,t){return t=Math.max(0,n.bandwidth()-2*t)/2,n.round()&&(t=Math.round(t)),e=>+n(e)+t}function wa(){return!this.__axis}function Aa(n,t){var e=[],r=null,o=null,i=6,a=6,u=3,l="undefined"!=typeof window&&window.devicePixelRatio>1?0:.5,c=n===ga||n===va?-1:1,s=n===va||n===da?"x":"y",f=n===ga||n===pa?ba:ya;function h(h){var g=null==r?t.ticks?t.ticks.apply(t,e):t.domain():r,d=null==o?t.tickFormat?t.tickFormat.apply(t,e):ha:o,p=Math.max(i,0)+u,v=t.range(),m=+v[0]+l,b=+v[v.length-1]+l,y=(t.bandwidth?xa:$a)(t.copy(),l),$=h.selection?h.selection():h,x=$.selectAll(".domain").data([null]),w=$.selectAll(".tick").data(g,t).order(),A=w.exit(),C=w.enter().append("g").attr("class","tick"),_=w.select("line"),k=w.select("text");x=x.merge(x.enter().insert("path",".tick").attr("class","domain").attr("stroke","currentColor")),w=w.merge(C),_=_.merge(C.append("line").attr("stroke","currentColor").attr(s+"2",c*i)),k=k.merge(C.append("text").attr("fill","currentColor").attr(s,c*p).attr("dy",n===ga?"0em":n===pa?"0.71em":"0.32em")),h!==$&&(x=x.transition(h),w=w.transition(h),_=_.transition(h),k=k.transition(h),A=A.transition(h).attr("opacity",ma).attr("transform",(function(n){return isFinite(n=y(n))?f(n+l):this.getAttribute("transform")})),C.attr("opacity",ma).attr("transform",(function(n){var t=this.parentNode.__axis;return f((t&&isFinite(t=t(n))?t:y(n))+l)}))),A.remove(),x.attr("d",n===va||n===da?a?"M"+c*a+","+m+"H"+l+"V"+b+"H"+c*a:"M"+l+","+m+"V"+b:a?"M"+m+","+c*a+"V"+l+"H"+b+"V"+c*a:"M"+m+","+l+"H"+b),w.attr("opacity",1).attr("transform",(function(n){return f(y(n)+l)})),_.attr(s+"2",c*i),k.attr(s,c*p).text(d),$.filter(wa).attr("fill","none").attr("font-size",10).attr("font-family","sans-serif").attr("text-anchor",n===da?"start":n===va?"end":"middle"),$.each((function(){this.__axis=y}))}return h.scale=function(n){return arguments.length?(t=n,h):t},h.ticks=function(){return e=fa.call(arguments),h},h.tickArguments=function(n){return arguments.length?(e=null==n?[]:fa.call(n),h):e.slice()},h.tickValues=function(n){return arguments.length?(r=null==n?null:fa.call(n),h):r&&r.slice()},h.tickFormat=function(n){return arguments.length?(o=n,h):o},h.tickSize=function(n){return arguments.length?(i=a=+n,h):i},h.tickSizeInner=function(n){return arguments.length?(i=+n,h):i},h.tickSizeOuter=function(n){return arguments.length?(a=+n,h):a},h.tickPadding=function(n){return arguments.length?(u=+n,h):u},h.offset=function(n){return arguments.length?(l=+n,h):l},h}function Ca(n){return Aa(pa,n)}var _a=jo("%I:%M:%S %p"),ka=jo("%I:%M %p"),Ma=jo("%B %d"),Da=function(n){return n.step()<6e4?_a:n.step()<864e5?ka:Ma},Ta=function(n){return{focusFormat:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n.format===Da(n.context)?null:t:(n.format=null==t?Da(context):t,n)}}},Ba=function(n){return{axis:function(){var t,e={context:n,size:n._size,scale:n._scale,_axis:Ca().scale(n._scale),format:Da(n),id:++n._id};return Object.assign(e,function(n){return{remove:function(t){var e=n.context;t.selectAll("svg").each((function(n){e.on("change.axis-"+n.id,null),e.on("focus.axis-"+n.id,null)})).remove()}}}(e),Ta(e),function(n){return{ticks:function(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];return n._axis.ticks(e),n}}}(e),(t=e,{orient:function(n){var e=t.context;switch(n){case"top":t._axis=Aa(ga,void 0).scale(e._scale);break;case"bottom":t._axis=Ca().scale(e._scale);break;case"left":t._axis=Aa(va,void 0).scale(e._scale);break;case"right":t._axis=Aa(da,void 0).scale(e._scale);break;default:console.warn("orient shall be one of bottom|top|left|right")}return t}}),function(n,t){return{render:function(e){var r=t._axis,o=t.scale,i=t.format,a=t.id,u=t.size,l=null,c=e.append("svg").datum({id:a}).attr("width",u).attr("height",Math.max(28,-r.tickSize())).append("g").attr("transform","translate(0,4)").call(r);n.on("change.axis-"+a,(function(){c.call(r),l||(l=lo(c.node().appendChild(c.selectAll("text").node().cloneNode(!0))).style("display","none").text(null))})),n.on("focus.axis-"+a,(function(n){if(l)if(null==n)l.style("display","none"),c.selectAll("text").style("fill-opacity",null);else{l.style("display",null).attr("x",n).text(i(o.invert(n)));var t=l.node().getComputedTextLength()+6;c.selectAll("text").style("fill-opacity",(function(e){return Math.abs(o(e)-n)<t?0:1}))}}))}}}(n,e))}}};function Sa(n,t){if((e=(n=t?n.toExponential(t-1):n.toExponential()).indexOf("e"))<0)return null;var e,r=n.slice(0,e);return[r.length>1?r[0]+r.slice(2):r,+n.slice(e+1)]}var Ua,Na=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function Fa(n){if(!(t=Na.exec(n)))throw new Error("invalid format: "+n);var t;return new za({fill:t[1],align:t[2],sign:t[3],symbol:t[4],zero:t[5],width:t[6],comma:t[7],precision:t[8]&&t[8].slice(1),trim:t[9],type:t[10]})}function za(n){this.fill=void 0===n.fill?" ":n.fill+"",this.align=void 0===n.align?">":n.align+"",this.sign=void 0===n.sign?"-":n.sign+"",this.symbol=void 0===n.symbol?"":n.symbol+"",this.zero=!!n.zero,this.width=void 0===n.width?void 0:+n.width,this.comma=!!n.comma,this.precision=void 0===n.precision?void 0:+n.precision,this.trim=!!n.trim,this.type=void 0===n.type?"":n.type+""}function La(n,t){var e=Sa(n,t);if(!e)return n+"";var r=e[0],o=e[1];return o<0?"0."+new Array(-o).join("0")+r:r.length>o+1?r.slice(0,o+1)+"."+r.slice(o+1):r+new Array(o-r.length+2).join("0")}Fa.prototype=za.prototype,za.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};var Ea={"%":(n,t)=>(100*n).toFixed(t),b:n=>Math.round(n).toString(2),c:n=>n+"",d:function(n){return Math.abs(n=Math.round(n))>=1e21?n.toLocaleString("en").replace(/,/g,""):n.toString(10)},e:(n,t)=>n.toExponential(t),f:(n,t)=>n.toFixed(t),g:(n,t)=>n.toPrecision(t),o:n=>Math.round(n).toString(8),p:(n,t)=>La(100*n,t),r:La,s:function(n,t){var e=Sa(n,t);if(!e)return n+"";var r=e[0],o=e[1],i=o-(Ua=3*Math.max(-8,Math.min(8,Math.floor(o/3))))+1,a=r.length;return i===a?r:i>a?r+new Array(i-a+1).join("0"):i>0?r.slice(0,i)+"."+r.slice(i):"0."+new Array(1-i).join("0")+Sa(n,Math.max(0,t+i-1))[0]},X:n=>Math.round(n).toString(16).toUpperCase(),x:n=>Math.round(n).toString(16)};function Ha(n){return n}var Ya,Oa,Ia=Array.prototype.map,ja=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];Ya=function(n){var t,e,r=void 0===n.grouping||void 0===n.thousands?Ha:(t=Ia.call(n.grouping,Number),e=n.thousands+"",function(n,r){for(var o=n.length,i=[],a=0,u=t[0],l=0;o>0&&u>0&&(l+u+1>r&&(u=Math.max(1,r-l)),i.push(n.substring(o-=u,o+u)),!((l+=u+1)>r));)u=t[a=(a+1)%t.length];return i.reverse().join(e)}),o=void 0===n.currency?"":n.currency[0]+"",i=void 0===n.currency?"":n.currency[1]+"",a=void 0===n.decimal?".":n.decimal+"",u=void 0===n.numerals?Ha:function(n){return function(t){return t.replace(/[0-9]/g,(function(t){return n[+t]}))}}(Ia.call(n.numerals,String)),l=void 0===n.percent?"%":n.percent+"",c=void 0===n.minus?"−":n.minus+"",s=void 0===n.nan?"NaN":n.nan+"";function f(n){var t=(n=Fa(n)).fill,e=n.align,f=n.sign,h=n.symbol,g=n.zero,d=n.width,p=n.comma,v=n.precision,m=n.trim,b=n.type;"n"===b?(p=!0,b="g"):Ea[b]||(void 0===v&&(v=12),m=!0,b="g"),(g||"0"===t&&"="===e)&&(g=!0,t="0",e="=");var y="$"===h?o:"#"===h&&/[boxX]/.test(b)?"0"+b.toLowerCase():"",$="$"===h?i:/[%p]/.test(b)?l:"",x=Ea[b],w=/[defgprs%]/.test(b);function A(n){var o,i,l,h=y,A=$;if("c"===b)A=x(n)+A,n="";else{var C=(n=+n)<0||1/n<0;if(n=isNaN(n)?s:x(Math.abs(n),v),m&&(n=function(n){n:for(var t,e=n.length,r=1,o=-1;r<e;++r)switch(n[r]){case".":o=t=r;break;case"0":0===o&&(o=r),t=r;break;default:if(!+n[r])break n;o>0&&(o=0)}return o>0?n.slice(0,o)+n.slice(t+1):n}(n)),C&&0==+n&&"+"!==f&&(C=!1),h=(C?"("===f?f:c:"-"===f||"("===f?"":f)+h,A=("s"===b?ja[8+Ua/3]:"")+A+(C&&"("===f?")":""),w)for(o=-1,i=n.length;++o<i;)if(48>(l=n.charCodeAt(o))||l>57){A=(46===l?a+n.slice(o+1):n.slice(o))+A,n=n.slice(0,o);break}}p&&!g&&(n=r(n,1/0));var _=h.length+n.length+A.length,k=_<d?new Array(d-_+1).join(t):"";switch(p&&g&&(n=r(k+n,k.length?d-A.length:1/0),k=""),e){case"<":n=h+n+A+k;break;case"=":n=h+k+n+A;break;case"^":n=k.slice(0,_=k.length>>1)+h+n+A+k.slice(_);break;default:n=k+h+n+A}return u(n)}return v=void 0===v?6:/[gprs]/.test(b)?Math.max(1,Math.min(21,v)):Math.max(0,Math.min(20,v)),A.toString=function(){return n+""},A}return{format:f,formatPrefix:function(n,t){var e,r=f(((n=Fa(n)).type="f",n)),o=3*Math.max(-8,Math.min(8,Math.floor((e=t,((e=Sa(Math.abs(e)))?e[1]:NaN)/3)))),i=Math.pow(10,-o),a=ja[8+o/3];return function(n){return r(i*n)+a}}}}({thousands:",",grouping:[3],currency:["$",""]}),Oa=Ya.format,Ya.formatPrefix;var Pa=function(n,t,e,r){var o="compose="+r+"&start_time="+n+"&end_time="+t+"&resolution="+function(n,t,e){var r=t-n;if(r>2419200)return 3600;var o=function(n){var t,e,r,o,i=[1,60,900,3600],a=i[0],u=i[i.length];if(n>=u)return u;if(n<=a)return a;for(r=n;r<=u;r++)if((t=i.indexOf(r))>-1){e=i[t];break}for(r=n;r>=a;r--)if((t=i.indexOf(r))>-1){o=i[t];break}return e-n<n-o?e:o}(e);return r>604800&&o<900?900:r>172800&&o<60?60:o}(n,t,e);return"https://metrics-api.librato.com/v1/metrics?"+o},Ra=function n(t,e,r){return{fire:function(o,i,a,u){var l=[],c=Pa(o,i,a,t),s="Basic "+btoa(e+":"+r);sa(c).header("X-Requested-With","XMLHttpRequest").header("Authorization",s).header("Librato-User-Agent","cubism/"+cubism.version).then((function(t){if(0!==t.measurements.length)if(t.measurements[0].series.forEach((function(n){l.push(n)})),"query"in t&&"next_time"in t.query)n(Pa(t.query.next_time,i,a));else{var e=function(n,t,e,r){for(var o=[],i=n;i<=t;i+=e){for(var a=[];r.length&&r[0].measure_time<=i;)a.push(r.shift().value);var u;u=a.length?a.reduce((function(n,t){return n+t}))/a.length:o.length?o[o.length-1]:0,o.push(u)}return o}(o,i,a,l);u(e)}})).catch((function(n){return console.error(n)}))}}},qa=function(n){return Math.floor(n/1e3)},Ga=function(n){return{librato:function(t,e){return{toString:function(){return"librato"},metric:function(r){return n.metric((function(n,o,i,a){Ra(r,t,e).fire(qa(n),qa(o),qa(i),(function(n){return a(null,n)}))}),r+="")}}}}},Wa=function(n){return Math.floor(n/1e3)},Va=function(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)},Za=function(n){return 16777214&n},Xa=function(n){return(n+1&16777214)-1},Ja=function(n){return{comparison:function(){var t=function(n){return{context:n,_width:n.size(),_height:120,_scale:jn().interpolate(bn),_primary:function(n){return n[0]},_secondary:function(n){return n[1]},_extent:null,_title:function(n){return n},_formatPrimary:Oa(".2s"),_formatChange:Oa("+.0%"),_colors:["#9ecae1","#225b84","#a1d99b","#22723a"],_strokeWidth:1.5}}(n);return Object.assign(t,function(n){return{remove:function(t){var e=n.context;t.on("mousemove.comparison",null).on("mouseout.comparison",null),t.selectAll("canvas").each((function(n){n.primary.on("change.comparison-"+n.id,null),n.secondary.on("change.comparison-"+n.id,null),e.on("change.comparison-"+n.id,null),e.on("focus.comparison-"+n.id,null)})).remove(),t.selectAll(".title,.value").remove()}}}(t),function(n){return{height:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._height:(n._height=+t,n)},primary:function(n){function t(){return n.apply(this,arguments)}return t.toString=function(){return n.toString()},t}((function(){return null===(arguments.length>0&&void 0!==arguments[0]?arguments[0]:null)?n._primary:(n._primary=primary,n)})),secondary:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._secondary:(n._secondary=t,n)},extent:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._extent:(n._extent=t,n)},scale:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._scale:(n._scale=t,n)},title:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._title:(n._title=t,n)},formatPrimary:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._formatPrimary:(n._formatPrimary=t,n)},formatChange:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._formatChange:(n._formatChange=t,n)},colors:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._colors:(n._colorscolors=t,n)},strokeWidth:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._strokeWidth:(n._strokeWidth=t,n)}}}(t),function(n){return{render:function(t){var e=n.context,r=n._width,o=n._height,a=n._scale,u=n._primary,l=n._secondary,c=n._extent,s=n._title,f=n._formatPrimary,h=n._formatChange,g=n._colors,d=n._strokeWidth;t.on("mousemove.comparison",(function(n){e.focus(Math.round(i.pointer(n)[0]))})).on("mouseout.comparison",(function(){return e.focus(null)})),t.append("canvas").attr("width",r).attr("height",o),t.append("span").attr("class","title").text(s),t.append("span").attr("class","value primary"),t.append("span").attr("class","value change"),t.each((function(n,t){var i=Va()+Va()+"-"+Va()+"-"+Va()+"-"+Va()+"-"+Va()+Va()+Va(),s="function"==typeof u?u.call(this,n,t):u,p="function"==typeof l?l.call(this,n,t):l,v="function"==typeof c?c.call(this,n,t):c,m=lo(this),b=m.select("canvas"),y=m.select(".value.primary"),$=m.select(".value.change"),x=null;b.datum({id:i,primary:s,secondary:p});var w=b.node().getContext("2d");function A(n,t){w.save(),w.clearRect(0,0,r,o);var i=s.extent(),u=p.extent(),l=null==v?i:v;a.domain(l).range([o,0]),x=i.concat(u).every(isFinite);var c=n/e.step()&1?Xa:Za;w.fillStyle=g[2];for(var f=0,h=r;f<h;++f){var m=a(s.valueAt(f)),b=a(p.valueAt(f));m<b&&w.fillRect(c(f),m,1,b-m)}w.fillStyle=g[0];for(var y=0,$=r;y<$;++y){var A=a(s.valueAt(y)),C=a(p.valueAt(y));A>C&&w.fillRect(c(y),C,1,A-C)}w.fillStyle=g[3];for(var _=0,k=r;_<k;++_){var M=a(s.valueAt(_));M<=a(p.valueAt(_))&&w.fillRect(c(_),M,1,d)}w.fillStyle=g[1];for(var D=0,T=r;D<T;++D){var B=a(s.valueAt(D));B>a(p.valueAt(D))&&w.fillRect(c(D),B-d,1,d)}w.restore()}var C=function(){var n=arguments.length>0&&void 0!==arguments[0]?arguments[0]:r-1,t=s.valueAt(n),e=p.valueAt(n),o=(t-e)/e;y.datum(t).text(isNaN(t)?null:f),$.datum(o).text(isNaN(o)?null:h).attr("class","value change "+(o>0?"positive":o<0?"negative":""))},_=function(n,t){A(n),C(),x&&(s.on("change.comparison-"+i,(function(n){return n})),p.on("change.comparison-"+i,(function(n){return n})))};s.on("change.comparison-"+i,_),p.on("change.comparison-"+i,_),e.on("change.comparison-"+i,A),e.on("focus.comparison-"+i,C)}))}}}(t))}}};u("prepare","beforechange","change","focus"),nr().range([0,1440]);var Qa=function(){var n={_id:1,_step:1e4,_size:1440,_serverDelay:5e3,_clientDelay:5e3,_event:u("prepare","beforechange","change","focus"),_start0:null,_stop0:null,_start1:null,_stop1:null,_timeout:null,_focus:null,_scale:nr().range([0,1440])},t=Object.assign(n,Ba(n),Ja(n),function(n){return{cube:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"";return{toString:function(){return t},metric:function(e){return n.metric((function(n,r,o,i){sa(t+"/1.0/metric?expression="+encodeURIComponent(e)+"&start="+ua(n)+"&stop="+ua(r)+"&step="+o).then((function(n){if(!n)return i(new Error("unable to load data"));i(null,n.map((function(n){return n.value})))}))}),e+="")}}}}}(n),function(n){return{clientDelay:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._clientDelay:(n._clientDelay=+t,co(n))}}}(n),function(n){return{focus:function(t){return n._event.call("focus",n,n._focus=t),n}}}(n),fo(n),function(n){return{on:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=n._event,o=n._focus,i=n._start1,a=n._stop1,u=n._start0,l=n._stop0;return null===e?r.on(t):(r.on(t,e),/^prepare(\.|$)/.test(t)&&e(i,a),/^beforechange(\.|$)/.test(t)&&e(u,l),/^change(\.|$)/.test(t)&&e(u,l),/^focus(\.|$)/.test(t)&&e(o),n)}}}(n),function(n){return{rule:function(){var t,e={_context:n,_metric:function(n){return n}};return Object.assign(e,(t=e,{remove:function(){var n=t._context;undefined.selectAll(".line").each((function(t){return n.on("focus.rule-"+t.id,null)})).remove()}}),function(n){return{metric:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._metric:(n._metric=t,n)}}}(e),function(n){return{render:function(t){var e=n._context,r=n._metric,o=++e._id,i=t.append("div").datum({id:o}).attr("class","line").style("position","absolute").style("top",0).style("bottom",0).style("width","1px").style("pointer-events","none");t.each((function(n,i){var a="function"==typeof r?r(n,i):r;if(a){var u=function(n,r){for(var o=[],i=0,u=e.size();i<u;++i)a.valueAt(i)&&o.push(i);var l=t.selectAll(".metric").data(o);l.exit().remove(),l.enter().append("div").attr("class","metric line").style("position","absolute").style("top",0).style("bottom",0).style("width","1px").style("pointer-events","none"),l.style("left",(function(n){return n+"px"}))};e.on("change.rule-"+o,u),a.on("change.rule-"+o,u)}})),e.on("focus.rule-"+o,(function(n){i.style("display",null==n?"none":null).style("left",null==n?null:"".concat(n,"px"))}))}}}(e))}}}(n),function(n){return{serverDelay:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._serverDelay:(n._serverDelay=+t,co(n))}}}(n),function(n){return{size:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._size:(n._scale.range([0,n._size=+t]),co(n))}}}(n),function(n){return{start:function(){var t=n._timeout,e=n._stop1,r=n._serverDelay,o=n._clientDelay,i=n._step,a=n._event,u=n._scale,l=n._size,c=n._focus;t&&clearTimeout(t);var s=+e+r-Date.now();return s<o&&(s+=i),n.timeout=setTimeout((function t(){n._stop1=new Date(Math.floor((Date.now()-r)/i)*i),n._start1=new Date(n._stop1-l*i),a.call("prepare",n,n._start1,n._stop1),setTimeout((function(){n.start0=n._start1,n.stop0=n._stop1,u.domain([n.start0,n.stop0]),a.call("beforechange",n,n._start1,n._stop1),a.call("change",n,n._start1,n._stop1),a.call("focus",n,c)}),o),n.timeout=setTimeout(t,i)}),s),n}}}(n),function(n){return{stop:function(){return n._timeout=clearTimeout(n._timeout),n}}}(n),function(n){return{step:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._step:(n._step=+t,co(n))}}}(n));n._timeout=setTimeout(t.start,10);var e=t.focus;lo(window).on("keydown.context-"+ ++t._id,(function(n){switch(!n.metaKey&&n.keyCode){case 37:null==e&&(t.focus=size-1),e>0&&t.focus(--t.focus);break;case 39:null==e&&(t.focus=size-2),e<size-1&&t.focus(++t.focus);break;default:return}n.preventDefault()}));var r=co(t);return Object.assign(r,function(n){return{horizon:function(){var t=document.createElement("canvas");t.width=n.size(),t.height=30;var e={_mode:"offset",_buffer:t,_width:t.width,_height:t.height,_scale:jn().interpolate(bn),_metric:function(n){return n},_extent:null,_title:function(n){return n},_format:Oa(".2s"),_colors:["#08519c","#3182bd","#6baed6","#bdd7e7","#bae4b3","#74c476","#31a354","#006d2c"]};return Object.assign(e,function(n){return{remove:function(t){t.on("mousemove.horizon",null).on("mouseout.horizon",null),t.selectAll("canvas").each((function(t){t.metric.on("change.horizon-"+t.id,null),n.on("change.horizon-"+t.id,null),n.on("focus.horizon-"+t.id,null)})).remove(),t.selectAll("._title,.value").remove()}}}(e),function(n){return{mode:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._mode:(n._mode=t+"",n)},height:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._height:(n._height=+t,n._buffer.height=+t,n)},metric:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._metric:(n._metric=t,n)},scale:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._scale:(n._scale=t,n)},extent:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._extent:(n._extent=t,n)},title:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._title:(n._title=t,n)},format:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._format:(n._format=t,n)},colors:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return null===t?n._colors:(n._colors=t,n)}}}(e),function(n,t){return{render:function(e){e.append("div").attr("a","b");var r=t._width,o=t._height,a=t._title,u=t._metric,l=t._colors,c=t._extent,s=t._scale,f=t._buffer,h=t._mode,g=t._format;e.on("mousemove.horizon",(function(t){n.focus(Math.round(i.pointer(t)[0]))})).on("mouseout.horizon",(function(){return n.focus(null)})),e.append("canvas").attr("width",r).attr("height",o),e.append("span").attr("class","title").text(a),e.append("span").attr("class","value"),e.each((function(t,e){var i,a,d=++n._id,p="function"==typeof u?u(t,e):u,v="function"==typeof l?l(t,e):l,m="function"==typeof c?c(t,e):c,b=n.step(),y=lo(this).select("canvas"),$=lo(this).select(".value"),x=v.length>>1,w=-1/0;y.datum({id:d,metric:p});var A=y.node().getContext("2d");function C(t,e){A.save();var u=p.extent();a=u.every(isFinite),null!=m&&(u=m);var l,c=0,g=Math.max(-u[0],u[1]);if(this===n){if(g===i){c=r-6;var d=(t-w)/b;if(d<r){var y=f.getContext("2d");y.clearRect(0,0,r,o),y.drawImage(A.canvas,d,0,r-d,o,0,0,r-d,o),A.clearRect(0,0,r,o),A.drawImage(y.canvas,0,0)}}w=t}s.domain([0,i=g]),A.clearRect(c,0,r-c,o);for(var $=0;$<x;++$){A.fillStyle=v[x+$];var C=($-x+1)*o;s.range([x*o+C,C]),C=s(0);for(var _,k=c,M=r;k<M;++k)(_=p.valueAt(k))<=0?l=!0:void 0!==_&&A.fillRect(k,_=s(_),1,C-_)}if(l){"offset"===h&&(A.translate(0,o),A.scale(1,-1));for(var D=0;D<x;++D){A.fillStyle=v[x-1-D];var T=(D-x+1)*o;s.range([x*o+T,T]),T=s(0);for(var B,S=c,U=r;S<U;++S)(B=p.valueAt(S))>=0||A.fillRect(S,s(-B),1,T-s(-B))}}A.restore()}var _=function(n){null==n&&(n=r-1);var t=p.valueAt(n);$.datum(t).text(isNaN(t)?null:g)};n.on("change.horizon-"+d,C),n.on("focus.horizon-"+d,_),p.on("change.horizon-"+d,(function(n,t){C(n),_(),a&&p.on("change.horizon-"+d,(function(n){return n}))}))}))}}}(n,e))}}}(r),function(n){return{gangliaWeb:function(t){var e=t.host||"",r=t.uriPathPrefix||"/ganglia2/";return"/"!==r[0]&&(r="/"+r),"/"!==r[r.length-1]&&(r+="/"),{toString:function(){return e+r},metric:function(t){var o=t.clusterName,i=t.metricName,a=t.hostName,u=t.onChangeCallback,l=void 0!==t.isReport&&t.isReport,c=t.titleGenerator||function(n){return"clusterName:".concat(o," metricName:").concat(i," hostName:").concat(a)},s=l?"g":"m";c(t);var f=n.metric((function(n,t,u,l){sa(e+r+"graph.php?"+"c=".concat(o,"&").concat(s,"=").concat(i,"&h=").concat(a)+"&cs="+n/1e3+"&ce="+t/1e3+"&step="+u/1e3+"&graphlot=1").then((function(n){if(null==n)return l(new Error("Unable to fetch GangliaWeb data"));l(null,n[0].data)})).catch((function(n){return l(new Error("Unable to fetch GangliaWeb data: Error ".concat(n)))}))}));return f.toString=function(){return c(t)},u&&f.on("change",u),f}}}}}(r),Ga(r),function(n){return{graphite:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"";return{toString:function(){return t},find:function(n,e){sa(t+"/metrics/find?format=completer&query="+encodeURIComponent(n)).then((function(n){if(!n)return e(new Error("unable to find metrics"));e(null,n.metrics.map((function(n){return n.path})))}))},metric:function(e){var r="sum",o=n.metric((function(n,o,i,a){var u,l=e;1e4!==i&&(l="summarize("+l+",'"+(i%36e5?i%6e4?i/1e3+"sec":i/6e4+"min":i/36e5+"hour")+"','"+r+"')"),(u=t+"/render?format=raw&target="+encodeURIComponent("alias("+l+",'')")+"&from="+Wa(n-2*i)+"&until="+Wa(o-1e3),fetch(u,void 0).then(la)).then((function(n){if(!n)return a(new Error("unable to load data"));a(null,function(n){var t=n.indexOf("|"),e=n.substring(0,t),r=e.lastIndexOf(","),o=e.lastIndexOf(",",r-1),i=e.lastIndexOf(",",o-1);return e.substring(i+1,o),e.substring(r+1),n.substring(t+1).split(",").slice(1).map((function(n){return+n}))}(n))}))}),e+="");return o.summarize=function(n){return r=n,o},o}}}}}(r))},Ka=c(531),nu=c(241),tu=c.n(nu);Ka.config.theme2.isDark?c(569):c(303);const eu=({height:n,width:t,data:r,options:a,stylesGetter:u})=>{const l=(0,o.useTheme2)();let c=Qa();const s=e().useCallback((n=>{if(!n||0===r.series.length)return;const t=864e5,e=7*t,o=4*e;let s=r.series[0].fields[0].values,f=s[0],h=s[s.length-1],g=h-f,d=n.clientWidth,p=Math.floor(g/d),v=[];for(let n=f;n<=h;n+=p)v.push(n);v.length;let m=r.series.map((function(n,t){return function(n,t,e,r){return r.metric((function(t,r,o,i){let a=n.fields[1].values,u=n.fields[0].values,l=[];if(e.length===a.length)l=a.map((function(n){return n}));else if(e.length>a.length){let n=0;l=tu().chain(e).map(function(n,t,e){return function(r,o){let i=n[e],a=null,u=null;return e+1<n.length&&(a=n[e+1],u=t[e+1]),null==u||r<u?i:(e++,a)}}(a,u,n)).value()}else{let n={summaryType:"avg"},t=u.map(((n,t)=>[n,a[t]]));l=tu().chain(e).map(function(n,t,e){return function(r,o){let i=null;o+1<n.length&&(i=n[o+1]);let a=t.filter((function(n){return n[0]>=r&&(null==i||n[0]<i)})).map((function(n){return n[1]}));return"sum"===e.summaryType?function(n){return n.reduce((function(n,t){return n+t}))}(a):"min"===e.summaryType?function(n){return n.reduce((function(n,t){return Math.min(n,t)}))}(a):"max"===e.summaryType?function(n){return n.reduce((function(n,t){return Math.max(n,t)}))}(a):function(n){return n.reduce((function(n,t){return n+t}))/n.length}(a)}}(e,t,n)).value()}i(null,l)}),n.fields[1].name)}(n,0,v,c)}));n.innerHTML="",n.className=u.wrapper;const b=i.create("div");b.node().className=u.d3outer,c.size(d).step(p);const y=i.create("div"),$=i.create("div");y.node().className=u.d3inner,$.selectAll(".axis").data(["bottom"]).enter().append("div").attr("class",(function(n){return n+" axis"})).each((function(n){let r=i.timeHour,a=6;g<72e5?(r=i.timeMinute,a=15):g<432e5?(r=i.timeHour,a=1):g<t?(r=i.timeHour,a=3):g<2*t?(r=i.timeHour,a=6):g<2*e?(r=i.timeDay,a=1):g<2*o&&(r=i.timeDay,a=2),c.axis().ticks(r,a).orient(n).render(i.select(this))}));const x=y.selectAll(".horizon").data(m).enter().insert("div",".bottom").attr("class","horizon"),w=y.append("div").attr("class","rule").attr("background-color",l.colors.primary.main).attr("id","rule");if(c.rule().render(w),a.automaticExtents?c.horizon().render(x):c.horizon().extent([a.extentMin,a.extentMax]).render(x),c.on("focus",(function(n){null!==n&&y.selectAll(".value").style("right",c.size()-n+"px")})),b.node().append(y.node()),b.node().append($.node()),n.append(b.node()),void 0!==a.text&&null!==a.text&&""!==a.text){let t=`${a.text}`;const e=i.create("div");e.node().className=u.textBox,e.append("div").text(t),n.append(e.node())}}),[l.colors.primary.main,c,r,a,u]);return e().createElement("div",{ref:s})},ru=new n.PanelPlugin((({options:n,data:t,width:i,height:a})=>{let u=!1;void 0!==n.text&&null!==n.text&&""!==n.text&&(u=!0);const l=(0,o.useStyles2)((n=>function(){let t="100%";return n&&(t="calc(100% - 2em)"),{wrapper:r.css`
        height: 100%;
        font-family: Open Sans;
        position: relative;
        overflow: hidden;
      `,d3inner:r.css`
        overflow: auto;
        height: ${"calc(100% - 28px)"};
      `,d3outer:r.css`
        position: relative;
        height: ${t};
        overflow: hidden;
      `,svg:r.css`
        position: absolute;
        top: 0;
        left: 0;
      `,textBox:r.css`
        max-height: 2em;
      `}})(u));return e().createElement("div",{className:(0,r.cx)(r.css`
          width: ${i}px;
          height: ${a}px;
        `)},e().createElement(eu,{height:a,width:i,data:t,options:n,stylesGetter:l}))})).setPanelOptions((n=>n.addBooleanSwitch({path:"automaticExtents",name:"Let cubism calculate the extent automatically",defaultValue:!0}).addNumberInput({path:"extentMax",name:"Extent max",defaultValue:10,showIf:n=>!1===n.automaticExtents}).addNumberInput({path:"extentMin",name:"Extent min",defaultValue:-10,showIf:n=>!1===n.automaticExtents}).addTextInput({path:"text",name:"Bottom label",description:"This is a label that is added at the bottom of the graph",defaultValue:""})))})(),s})()));
//# sourceMappingURL=module.js.map